"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Accordion = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Accordion, _Component);
  var _super = _createSuper(Accordion);
  function Accordion(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Accordion);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetHeight", function (callback) {
      var _this$accordionConten;
      var el = (_this$accordionConten = _this.accordionContent) === null || _this$accordionConten === void 0 ? void 0 : _this$accordionConten.current;
      if (_this.state.collapsed || !el) {
        return;
      }
      _this.setState({
        contentHeight: 'auto'
      }, function () {
        return _this.setState({
          contentHeight: el.offsetHeight
        }, function () {
          var _this$props$onResetHe, _this$props;
          callback === null || callback === void 0 ? void 0 : callback();
          (_this$props$onResetHe = (_this$props = _this.props).onResetHeight) === null || _this$props$onResetHe === void 0 ? void 0 : _this$props$onResetHe.call(_this$props, el.offsetHeight);
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "collpase", function () {
      _this.setState({
        collapsed: true
      }, function () {
        var _this$props$onCollpas, _this$props2, _this$props$onChange, _this$props3;
        (_this$props$onCollpas = (_this$props2 = _this.props).onCollpase) === null || _this$props$onCollpas === void 0 ? void 0 : _this$props$onCollpas.call(_this$props2);
        (_this$props$onChange = (_this$props3 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props3, true);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "expand", function () {
      _this.setState({
        collapsed: false
      }, function () {
        var _this$props$onExpand, _this$props4, _this$props$onChange2, _this$props5;
        (_this$props$onExpand = (_this$props4 = _this.props).onExpand) === null || _this$props$onExpand === void 0 ? void 0 : _this$props$onExpand.call(_this$props4);
        (_this$props$onChange2 = (_this$props5 = _this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props5, false);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      _this.state.collapsed ? _this.expand() : _this.collpase();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "init", function () {
      if (!_this.props.collapsed) {
        _this.resetHeight();
      } else {
        setTimeout(function () {
          _this.setState({
            collapsed: false
          }, function () {
            _this.resetHeight(function () {
              _this.setState({
                collapsed: _this.props.collapsed
              });
            });
          });
        }, 0);
      }
    });
    _this.accordionContent = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      collapsed: props.collapsed,
      contentHeight: null
    };
    return _this;
  }
  (0, _createClass2["default"])(Accordion, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.init();
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
        children = _this$props6.children,
        className = _this$props6.className,
        style = _this$props6.style,
        title = _this$props6.title,
        collapseIcon = _this$props6.collapseIcon,
        titleRenderer = _this$props6.titleRenderer;
      var _this$state = this.state,
        collapsed = _this$state.collapsed,
        contentHeight = _this$state.contentHeight;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('accordion', (0, _defineProperty2["default"])({
          collapsed: collapsed
        }, className, className)),
        style: style
      }, titleRenderer ? typeof titleRenderer === 'function' ? titleRenderer(this.handleClick) : /*#__PURE__*/(0, _react.cloneElement)(titleRenderer, {
        onClick: this.handleClick
      }) : /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        className: "accordion-title",
        theme: _Theme["default"].SECONDARY,
        value: title,
        rightIconCls: collapseIcon,
        onClick: this.handleClick
      }), /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.accordionContent,
        className: "accordion-content",
        style: {
          height: contentHeight
        }
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        collapsed: _ComponentUtil["default"].getDerivedState(props, state, 'collapsed')
      };
    }
  }]);
  return Accordion;
}(_react.Component);
(0, _defineProperty2["default"])(Accordion, "Theme", _Theme["default"]);
Accordion.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The accordion's title.
   */
  title: _propTypes["default"].any,
  collapsed: _propTypes["default"].bool,
  titleRenderer: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func]),
  /**
   * Collapse icon.
   */
  collapseIcon: _propTypes["default"].string,
  /**
   * Callback function fired when collpase the accordion.
   */
  onCollpase: _propTypes["default"].func,
  /**
   * Callback function fired when expand the accordion.
   */
  onExpand: _propTypes["default"].func,
  /**
   * Callback function fired when change the status of accordion.
   */
  onChange: _propTypes["default"].func,
  onResetHeight: _propTypes["default"].func
};
Accordion.defaultProps = {
  title: 'title',
  collapsed: false,
  collapseIcon: 'fas fa-angle-down'
};
var _default = Accordion;
exports["default"] = _default;