"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _PositionPop = _interopRequireDefault(require("../_PositionPop"));
var _Paper = _interopRequireDefault(require("../Paper"));
var _FlatButton = _interopRequireDefault(require("../FlatButton"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _PopManagement = _interopRequireDefault(require("../_vendors/PopManagement"));
var _excluded = ["children", "className", "modalClassName", "position", "disabled", "showModal", "title", "buttons", "isLoading", "visible", "okButtonVisible", "okButtonText", "okButtonIconCls", "okButtonTheme", "okButtonDisabled", "okButtonIsLoading", "cancelButtonVisible", "cancelButtonText", "cancelButtonIconCls", "cancelButtonDisabled", "cancelButtonIsLoading", "cancelButtonTheme", "closeButtonVisible", "closeIconCls", "isBlurClose", "isEscClose", "onRequestClose", "onOKButtonClick", "onCloseButtonClick", "onCancelButtonClick"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Dialog = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Dialog, _Component);
  var _super = _createSuper(Dialog);
  function Dialog(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Dialog);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      var _this$pop, _this$pop$current, _this$pop$current$get;
      return (_this$pop = _this.pop) === null || _this$pop === void 0 ? void 0 : (_this$pop$current = _this$pop.current) === null || _this$pop$current === void 0 ? void 0 : (_this$pop$current$get = _this$pop$current.getEl) === null || _this$pop$current$get === void 0 ? void 0 : _this$pop$current$get.call(_this$pop$current);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOkButtonClick", function () {
      var _this$props = _this.props,
        visible = _this$props.visible,
        onOKButtonClick = _this$props.onOKButtonClick;
      visible && (onOKButtonClick === null || onOKButtonClick === void 0 ? void 0 : onOKButtonClick(function () {
        _this.setState({
          visible: false
        }, function () {
          var _this$props$onRequest, _this$props2;
          return (_this$props$onRequest = (_this$props2 = _this.props).onRequestClose) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call(_this$props2);
        });
      }));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCancelButtonClick", function () {
      var _this$props$onCancelB, _this$props3;
      (_this$props$onCancelB = (_this$props3 = _this.props).onCancelButtonClick) === null || _this$props$onCancelB === void 0 ? void 0 : _this$props$onCancelB.call(_this$props3);
      _this.setState({
        visible: false
      }, function () {
        var _this$props$onRequest2, _this$props4;
        return (_this$props$onRequest2 = (_this$props4 = _this.props).onRequestClose) === null || _this$props$onRequest2 === void 0 ? void 0 : _this$props$onRequest2.call(_this$props4);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleCloseButtonClick", function () {
      var _this$props$onCloseBu, _this$props5;
      (_this$props$onCloseBu = (_this$props5 = _this.props).onCloseButtonClick) === null || _this$props$onCloseBu === void 0 ? void 0 : _this$props$onCloseBu.call(_this$props5);
      _this.setState({
        visible: false
      }, function () {
        var _this$props$onRequest3, _this$props6;
        return (_this$props$onRequest3 = (_this$props6 = _this.props).onRequestClose) === null || _this$props$onRequest3 === void 0 ? void 0 : _this$props$onRequest3.call(_this$props6);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props$onRender, _this$props7;
      _PopManagement["default"].push((0, _assertThisInitialized2["default"])(_this), {
        shouldLockBody: _this.props.showModal
      });
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      (_this$props$onRender = (_this$props7 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call.apply(_this$props$onRender, [_this$props7].concat(args));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function () {
      var _this$props$onDestroy, _this$props8;
      _PopManagement["default"].pop((0, _assertThisInitialized2["default"])(_this));
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      (_this$props$onDestroy = (_this$props8 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call.apply(_this$props$onDestroy, [_this$props8].concat(args));
    });
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(Dialog, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _PopManagement["default"].pop(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props9 = this.props,
        children = _this$props9.children,
        className = _this$props9.className,
        modalClassName = _this$props9.modalClassName,
        position = _this$props9.position,
        disabled = _this$props9.disabled,
        showModal = _this$props9.showModal,
        title = _this$props9.title,
        buttons = _this$props9.buttons,
        isLoading = _this$props9.isLoading,
        visible = _this$props9.visible,
        okButtonVisible = _this$props9.okButtonVisible,
        okButtonText = _this$props9.okButtonText,
        okButtonIconCls = _this$props9.okButtonIconCls,
        okButtonTheme = _this$props9.okButtonTheme,
        okButtonDisabled = _this$props9.okButtonDisabled,
        okButtonIsLoading = _this$props9.okButtonIsLoading,
        cancelButtonVisible = _this$props9.cancelButtonVisible,
        cancelButtonText = _this$props9.cancelButtonText,
        cancelButtonIconCls = _this$props9.cancelButtonIconCls,
        cancelButtonDisabled = _this$props9.cancelButtonDisabled,
        cancelButtonIsLoading = _this$props9.cancelButtonIsLoading,
        cancelButtonTheme = _this$props9.cancelButtonTheme,
        closeButtonVisible = _this$props9.closeButtonVisible,
        closeIconCls = _this$props9.closeIconCls,
        isBlurClose = _this$props9.isBlurClose,
        isEscClose = _this$props9.isEscClose,
        onRequestClose = _this$props9.onRequestClose,
        onOKButtonClick = _this$props9.onOKButtonClick,
        onCloseButtonClick = _this$props9.onCloseButtonClick,
        onCancelButtonClick = _this$props9.onCancelButtonClick,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props9, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('dialog', (0, _defineProperty2["default"])({}, className, className)),
        position: position,
        visible: visible,
        container: /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
          depth: 6
        }),
        showModal: showModal,
        modalClassName: modalClassName,
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }), function (popEl) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "dialog-title"
        }, title, closeButtonVisible ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          className: "dialog-title-close-button",
          iconCls: closeIconCls,
          disabled: disabled,
          onClick: _this2.handleCloseButtonClick
        }) : null), /*#__PURE__*/_react["default"].createElement("div", {
          className: "dialog-content"
        }, typeof children === 'function' ? children(popEl && popEl.querySelector('.dialog-content'), popEl) : children), /*#__PURE__*/_react["default"].createElement("div", {
          className: "dialog-buttons"
        }, buttons ? _react.Children.map(buttons, function (button) {
          return /*#__PURE__*/(0, _react.cloneElement)(button, {
            isLoading: button.props.isLoading || isLoading,
            disabled: button.props.disabled || disabled
          });
        }) : null, !buttons && okButtonVisible ? /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
          className: "ok-button",
          value: okButtonText,
          iconCls: okButtonIconCls,
          theme: okButtonTheme,
          disabled: okButtonDisabled,
          isLoading: isLoading || okButtonIsLoading,
          disableTouchRipple: true,
          onClick: _this2.handleOkButtonClick
        }) : null, !buttons && cancelButtonVisible ? /*#__PURE__*/_react["default"].createElement(_FlatButton["default"], {
          className: "cancel-button",
          value: cancelButtonText,
          iconCls: cancelButtonIconCls,
          theme: cancelButtonTheme,
          disabled: cancelButtonDisabled,
          isLoading: isLoading || cancelButtonIsLoading,
          disableTouchRipple: true,
          onClick: _this2.handleCancelButtonClick
        }) : null));
      });
    }
  }]);
  return Dialog;
}(_react.Component);
(0, _defineProperty2["default"])(Dialog, "ButtonTheme", _Theme["default"]);
(0, _defineProperty2["default"])(Dialog, "Position", _Position["default"]);
Dialog.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The css class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The css class name of the modal.
   */
  modalClassName: _propTypes["default"].string,
  /**
   * The styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * The dialog alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true,the element will disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,dialog box will display.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the pop-up box will be displayed in the mask layer, or the pop-up box will appear below the element.
   */
  showModal: _propTypes["default"].bool,
  /**
   * Set the title of dialog.
   */
  title: _propTypes["default"].any,
  /**
   * If true,when press down mouse the pop-up box will closed.
   */
  isBlurClose: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  /**
   * If true, the OK button will display.
   */
  okButtonVisible: _propTypes["default"].bool,
  /**
   * Set the text value of the OK button.
   */
  okButtonText: _propTypes["default"].string,
  /**
   * Set the icon class of the OK button.
   */
  okButtonIconCls: _propTypes["default"].string,
  /**
   * If true, the OK button will disabled.
   */
  okButtonDisabled: _propTypes["default"].bool,
  /**
   * If true, the ok button will have loading effect.
   */
  okButtonIsLoading: _propTypes["default"].bool,
  /**
   * Set theme of OK button.
   */
  okButtonTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * If true, the cancel button will display.
   */
  cancelButtonVisible: _propTypes["default"].bool,
  /**
   * Set the text value of the cancel button.
   */
  cancelButtonText: _propTypes["default"].string,
  /**
   * Set the icon class of the cancel button.
   */
  cancelButtonIconCls: _propTypes["default"].string,
  /**
   * If true, the cancel button will disabled.
   */
  cancelButtonDisabled: _propTypes["default"].bool,
  /**
   * If true, the cancel button will have loading effect.
   */
  cancelButtonIsLoading: _propTypes["default"].bool,
  /**
   * Set theme of cancel button.
   */
  cancelButtonTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * If true, the close button in title will display.
   */
  closeButtonVisible: _propTypes["default"].bool,
  closeIconCls: _propTypes["default"].string,
  isEscClose: _propTypes["default"].bool,
  /**
   * The buttons of Dialog.
   */
  buttons: _propTypes["default"].any,
  /**
   * The function of dialog render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function that trigger when click submit.
   */
  onRequestClose: _propTypes["default"].func,
  /**
   * Callback function fired when click the ok button.
   */
  onOKButtonClick: _propTypes["default"].func,
  /**
   * Callback function fired when click the cancel button.
   */
  onCancelButtonClick: _propTypes["default"].func,
  /**
   * Callback function fired when click the close button.
   */
  onCloseButtonClick: _propTypes["default"].func,
  onDestroy: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
Dialog.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].CENTER,
  disabled: false,
  visible: false,
  showModal: true,
  isBlurClose: false,
  isLoading: false,
  okButtonVisible: true,
  okButtonText: 'OK',
  okButtonDisabled: false,
  okButtonIsLoading: false,
  okButtonTheme: _Theme["default"].SUCCESS,
  cancelButtonVisible: true,
  cancelButtonText: 'Cancel',
  cancelButtonDisabled: false,
  cancelButtonIsLoading: false,
  cancelButtonTheme: _Theme["default"].DEFAULT,
  closeButtonVisible: true,
  closeIconCls: 'fas fa-times',
  isEscClose: true
};
var _default = Dialog;
exports["default"] = _default;