"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _PositionPop = _interopRequireDefault(require("../_PositionPop"));
var _Notification = _interopRequireDefault(require("../_Notification"));
var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _NotificationCalculation = _interopRequireDefault(require("../_vendors/NotificationCalculation"));
var _excluded = ["className", "position", "closeIconCls", "closeIconVisible", "closeButtonVisible", "closeButtonValue", "duration", "parentEl", "onNotificationPop"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Notifier = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Notifier, _Component);
  var _super = _createSuper(Notifier);
  function Notifier(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Notifier);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addNotification", function (notification) {
      var notifications = _this.state.notifications;
      if (_NotificationCalculation["default"].isPositiveSequence(_this.props.position)) {
        notifications.push(_objectSpread(_objectSpread({}, notification), {}, {
          notificationId: _NotificationCalculation["default"].getNotificationsKey()
        }));
      } else {
        notifications.unshift(_objectSpread(_objectSpread({}, notification), {}, {
          notificationId: _NotificationCalculation["default"].getNotificationsKey()
        }));
      }
      _this.setState({
        notifications: notifications,
        visible: true
      }, function () {
        var _this$popInstance, _this$popInstance$res;
        return (_this$popInstance = _this.popInstance) === null || _this$popInstance === void 0 ? void 0 : (_this$popInstance$res = _this$popInstance.resetPosition) === null || _this$popInstance$res === void 0 ? void 0 : _this$popInstance$res.call(_this$popInstance);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeNotification", function (notificationId) {
      var notifications = _this.state.notifications;
      if (!notifications || notifications.length < 1) {
        return;
      }
      notifications.splice(notifications.findIndex(function (item) {
        return item.notificationId === notificationId;
      }), 1);
      _this.setState({
        notifications: notifications
      }, function () {
        if (notifications.length < 1) {
          _this.setState({
            visible: false
          }, function () {
            _this.popInstance && _this.popInstance.resetPosition();
          });
        }
      });
    });
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.popInstance = null;
    _this.state = {
      visible: false,
      notifications: []
    };
    return _this;
  }
  (0, _createClass2["default"])(Notifier, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$pop;
      this.popInstance = ((_this$pop = this.pop) === null || _this$pop === void 0 ? void 0 : _this$pop.current) || null;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this$props$notificat;
      if (((_this$props$notificat = this.props.notifications) === null || _this$props$notificat === void 0 ? void 0 : _this$props$notificat.length) > 0) {
        var _this$popInstance2, _this$popInstance2$re, _this$props$onNotific, _this$props;
        (_this$popInstance2 = this.popInstance) === null || _this$popInstance2 === void 0 ? void 0 : (_this$popInstance2$re = _this$popInstance2.resetPosition) === null || _this$popInstance2$re === void 0 ? void 0 : _this$popInstance2$re.call(_this$popInstance2);
        (_this$props$onNotific = (_this$props = this.props).onNotificationPop) === null || _this$props$onNotific === void 0 ? void 0 : _this$props$onNotific.call(_this$props);
      }
    }

    /**
     * public
     * @param notification
     */
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        position = _this$props2.position,
        closeIconCls = _this$props2.closeIconCls,
        closeIconVisible = _this$props2.closeIconVisible,
        closeButtonVisible = _this$props2.closeButtonVisible,
        closeButtonValue = _this$props2.closeButtonValue,
        duration = _this$props2.duration,
        parentEl = _this$props2.parentEl,
        onNotificationPop = _this$props2.onNotificationPop,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      var _this$state = this.state,
        notifications = _this$state.notifications,
        visible = _this$state.visible;
      return /*#__PURE__*/_react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('notifier', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "notifier-".concat(position), position), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        visible: visible,
        position: position,
        parentEl: parentEl
      }), (notifications === null || notifications === void 0 ? void 0 : notifications.map(function (options) {
        return /*#__PURE__*/_react["default"].createElement(_Notification["default"], (0, _extends2["default"])({}, options, {
          key: options.notificationId,
          closeIconCls: 'closeIconCls' in options ? options.closeIconCls : closeIconCls,
          closeIconVisible: 'closeIconVisible' in options ? options.closeIconVisible : closeIconVisible,
          closeButtonVisible: 'closeButtonVisible' in options ? options.closeButtonVisible : closeButtonVisible,
          closeButtonValue: 'closeButtonValue' in options ? options.closeButtonValue : closeButtonValue,
          duration: 'duration' in options ? options.duration : duration,
          onRequestClose: _this2.removeNotification
        }));
      })) || null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (!props.notifications || props.notifications.length < 1) {
        return null;
      }
      var notifications = (0, _cloneDeep["default"])(props.notifications);
      for (var i = 0, len = notifications.length; i < len; i++) {
        if ((0, _typeof2["default"])(notifications[i]) !== 'object') {
          notifications[i] = {
            message: notifications[i]
          };
        }
        notifications[i].notificationId = _NotificationCalculation["default"].getNotificationsKey();
      }
      if (_NotificationCalculation["default"].isPositiveSequence(props.position)) {
        notifications = [].concat((0, _toConsumableArray2["default"])(state.notifications), (0, _toConsumableArray2["default"])(notifications));
      } else {
        notifications = [].concat((0, _toConsumableArray2["default"])(notifications.reverse()), (0, _toConsumableArray2["default"])(state.notifications));
      }
      return {
        prevProps: props,
        notifications: notifications,
        visible: true
      };
    }
  }]);
  return Notifier;
}(_react.Component);
(0, _defineProperty2["default"])(Notifier, "Type", _MsgType["default"]);
(0, _defineProperty2["default"])(Notifier, "Position", _Position["default"]);
Notifier.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * Children passed into the notifier.
   */
  notifications: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of notification.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the notification.
     */
    style: _propTypes["default"].object,
    /**
     * The type of notification.
     */
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
    /**
     * The title of notification.
     */
    title: _propTypes["default"].string,
    /**
     * The message of notification.
     */
    message: _propTypes["default"].string,
    /**
     * The icon class name of notification.
     */
    iconCls: _propTypes["default"].string,
    /**
     * The close icon class name of notification.
     */
    closeIconCls: _propTypes["default"].string,
    closeIconVisible: _propTypes["default"].bool,
    closeButtonVisible: _propTypes["default"].bool,
    closeButtonValue: _propTypes["default"].string,
    /**
     * The duration of notification.
     */
    duration: _propTypes["default"].number
  }), _propTypes["default"].string, _propTypes["default"].number])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The close icon class name of notification.
   */
  closeIconCls: _propTypes["default"].string,
  closeIconVisible: _propTypes["default"].bool,
  closeButtonVisible: _propTypes["default"].bool,
  closeButtonValue: _propTypes["default"].string,
  /**
   * The duration of notification.
   */
  duration: _propTypes["default"].number,
  /**
   * Callback function fired when the notifier pop.
   */
  onNotificationPop: _propTypes["default"].func
};
Notifier.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].BOTTOM_RIGHT,
  duration: 0
};
var _default = Notifier;
exports["default"] = _default;