"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Radio = _interopRequireDefault(require("../Radio"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var RadioGroup = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RadioGroup, _Component);
  var _super = _createSuper(RadioGroup);
  function RadioGroup(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, RadioGroup);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (item) {
      var _this$props = _this.props,
        valueField = _this$props.valueField,
        disabled = _this$props.disabled;
      _this.setState({
        value: item === null || item === void 0 ? void 0 : item[valueField]
      }, function () {
        var _this$props$onChange, _this$props2;
        return !disabled && ((_this$props$onChange = (_this$props2 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props2, item === null || item === void 0 ? void 0 : item[valueField]));
      });
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }
  (0, _createClass2["default"])(RadioGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        theme = _this$props3.theme,
        name = _this$props3.name,
        valueField = _this$props3.valueField,
        displayField = _this$props3.displayField,
        uncheckedIconCls = _this$props3.uncheckedIconCls,
        checkedIconCls = _this$props3.checkedIconCls,
        disabled = _this$props3.disabled,
        data = _this$props3.data,
        _onCheck = _this$props3.onCheck,
        value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('radio-group', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, (data === null || data === void 0 ? void 0 : data.map(function (item, index) {
        return item ? /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          key: index,
          className: item.className || null,
          style: item.style,
          uncheckedIconCls: item.uncheckedIconCls || uncheckedIconCls,
          checkedIconCls: item.checkedIconCls || checkedIconCls,
          theme: item.theme || theme,
          name: name,
          label: item[displayField],
          value: item[valueField],
          checked: item[valueField] === value,
          disabled: disabled || item.disabled,
          tip: item.tip,
          tipPosition: item.tipPosition,
          onChange: function onChange() {
            return _this2.handleChange(item);
          },
          onCheck: function onCheck(e) {
            return _onCheck === null || _onCheck === void 0 ? void 0 : _onCheck(item, e);
          }
        }) : null;
      })) || null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return RadioGroup;
}(_react.Component);
(0, _defineProperty2["default"])(RadioGroup, "Theme", _Theme["default"]);
RadioGroup.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The RadioGroup theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The name of Radio.
   */
  name: _propTypes["default"].string,
  /**
   * The data of GroupRadio.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of Radio component.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of Radio component.
     */
    style: _propTypes["default"].object,
    /**
     * The RadioGroup theme.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The label text of Radio component.
     */
    label: _propTypes["default"].any,
    /**
     * The value of Radio component.
     */
    value: _propTypes["default"].any,
    /**
     * If true,the Radio will be disabled.
     */
    disabled: _propTypes["default"].bool,
    tip: _propTypes["default"].any,
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"]))
  })).isRequired,
  /**
   * The value of RadioGroup component.
   */
  value: _propTypes["default"].any,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  uncheckedIconCls: _propTypes["default"].string,
  checkedIconCls: _propTypes["default"].string,
  /**
   * If true,the RadioGroup will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * Callback function fired when the value of RadioGroup changed.
   */
  onChange: _propTypes["default"].func,
  onCheck: _propTypes["default"].func
};
RadioGroup.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  data: [],
  valueField: 'value',
  displayField: 'label',
  uncheckedIconCls: 'far fa-circle',
  checkedIconCls: 'fas fa-dot-circle',
  disabled: false
};
var _default = RadioGroup;
exports["default"] = _default;