"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Slider = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Slider, _Component);
  var _super = _createSuper(Slider);
  function Slider(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Slider);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPosition", function (ev) {
      var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
      var scrollLeft = document.documentElement.scrollLeft || document.body.scrollLeft;
      return {
        x: ev.clientX + scrollLeft,
        y: ev.clientY + scrollTop
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getElementLeft", function (element) {
      if (!element) {
        return 0;
      }
      var offsetLeft = element.offsetLeft;
      var current = element.offsetParent;
      while (current !== null) {
        offsetLeft += current.offsetLeft;
        current = current.offsetParent;
      }
      return offsetLeft;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDown", function (ev) {
      if (_this.props.disabled) {
        return;
      }
      var element = ev.target;
      if (element.getAttribute('class').indexOf('left') > -1) {
        _this.setState({
          shadow: 'left'
        });
      } else {
        _this.setState({
          shadow: 'right'
        });
      }
      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "throttleMove", (0, _throttle["default"])(function (e) {
      _this.handleMove(e);
    }, 16));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMove", function (ev) {
      if (_this.state.shadow) {
        var offsetLeft = _this.getPosition(ev).x - _this.getElementLeft(_this.sliderBoxEl);
        var leftPosition = _this.props.width > offsetLeft ? offsetLeft : _this.props.width;
        leftPosition = leftPosition > 0 ? leftPosition : 0;
        if (_this.props.ruler) {
          leftPosition = _this.getNearest(leftPosition);
        }
        var value = _this.getValueFromPosition(leftPosition).toFixed(_this.props.decimalPlaces);
        if (_this.state.shadow === 'left') {
          _this.setState({
            left: value
          }, function () {
            _this.handleChange(value, _this.state.right);
          });
        } else {
          _this.setState({
            right: value
          }, function () {
            _this.handleChange(_this.state.left, value);
          });
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (left, right) {
      _this.props.onChange && _this.props.onChange(left, right);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleUp", function () {
      _this.setState({
        shadow: ''
      }, function () {
        _this.props.onBlur && _this.props.onBlur(_this.state.left, _this.state.right);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOver", function (ev) {
      var element = ev.target;
      if (element.getAttribute('class').indexOf('left') > -1) {
        _this.setState({
          tip: 'left'
        });
      } else {
        _this.setState({
          tip: 'right'
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOut", function () {
      _this.setState({
        tip: ''
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (ev) {
      if (_this.props.disabled) {
        return;
      }
      var offsetLeft = _this.getElementLeft(_this.sliderBoxEl);
      var clickLeft = _this.getPosition(ev).x - offsetLeft;
      var _this$getPositionFrom = _this.getPositionFromValue(_this.state.left, _this.state.right),
        leftPosition = _this$getPositionFrom.leftPosition,
        rightPosition = _this$getPositionFrom.rightPosition;
      if (_this.props.ruler) {
        clickLeft = _this.getNearest(clickLeft);
      }
      if (Math.abs(leftPosition - clickLeft) > Math.abs(rightPosition - clickLeft) || _this.props.leftPoint === false) {
        var value = _this.getValueFromPosition(clickLeft).toFixed(_this.props.decimalPlaces);
        _this.setState({
          right: value
        }, function () {
          _this.handleChange(_this.state.left, value);
        });
      } else {
        var _value = _this.getValueFromPosition(clickLeft).toFixed(_this.props.decimalPlaces);
        _this.setState({
          left: _value
        }, function () {
          _this.handleChange(_value, _this.state.right);
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getNearest", function (clickLeft) {
      var _this$props = _this.props,
        width = _this$props.width,
        ruler = _this$props.ruler,
        scale = _this$props.scale;
      var scaleValue = _this.getScaleValueAndLabel(scale)[0],
        min = scaleValue[0],
        max = scaleValue[scaleValue.length - 1];
      var nearest = Math.round(clickLeft * (max - min) / (width * ruler)) * ruler / (max - min) * width;
      return nearest > width ? width : nearest;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScaleValueAndLabel", function (scale) {
      var scaleValue = [],
        scaleLabel = [];
      if (scale.length > 0) {
        scale.forEach(function (item) {
          scaleValue.push((0, _typeof2["default"])(item) === 'object' ? item.value : item);
          scaleLabel.push((0, _typeof2["default"])(item) === 'object' ? item.label : item);
        });
      }
      return [scaleValue, scaleLabel];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getValueFromPosition", function (position) {
      var _this$props2 = _this.props,
        scale = _this$props2.scale,
        width = _this$props2.width;
      var _this$getScaleValueAn = _this.getScaleValueAndLabel(scale),
        _this$getScaleValueAn2 = (0, _slicedToArray2["default"])(_this$getScaleValueAn, 1),
        scaleValue = _this$getScaleValueAn2[0];
      return position / width * (scaleValue[scaleValue.length - 1] - scaleValue[0]) + scaleValue[0];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPositionFromValue", function (left, right) {
      var _this$props3 = _this.props,
        scale = _this$props3.scale,
        width = _this$props3.width;
      var _this$getScaleValueAn3 = _this.getScaleValueAndLabel(scale),
        _this$getScaleValueAn4 = (0, _slicedToArray2["default"])(_this$getScaleValueAn3, 1),
        scaleValue = _this$getScaleValueAn4[0];
      var min = Math.min(scaleValue[0], scaleValue[scaleValue.length - 1]),
        max = Math.max(scaleValue[0], scaleValue[scaleValue.length - 1]);
      var leftValue = parseFloat(left || scaleValue[0]);
      var rightValue = parseFloat(right || scaleValue[0]);
      leftValue = leftValue > max ? max : leftValue < min ? min : leftValue;
      rightValue = rightValue > max ? max : rightValue < min ? min : rightValue;
      var leftPosition = (leftValue - scaleValue[0]) / (scaleValue[scaleValue.length - 1] - scaleValue[0]) * width,
        rightPosition = (rightValue - scaleValue[0]) / (scaleValue[scaleValue.length - 1] - scaleValue[0]) * width;
      return {
        leftPosition: leftPosition,
        rightPosition: rightPosition
      };
    });
    _this.sliderBox = /*#__PURE__*/(0, _react.createRef)();
    _this.sliderBoxEl = null;
    _this.circleLeft = /*#__PURE__*/(0, _react.createRef)();
    _this.circleRight = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      left: props.left || 0,
      right: props.right || 0,
      shadow: '',
      tip: ''
    };
    return _this;
  }
  (0, _createClass2["default"])(Slider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.sliderBoxEl = this.sliderBox && this.sliderBox.current;
      _Event["default"].addEvent(document, 'mousemove', this.throttleMove);
      _Event["default"].addEvent(document, 'mouseup', this.handleUp);

      // if (this.circleRight && this.circleRight.current) {
      _Event["default"].addEvent(this.circleRight.current, 'mouseover', this.handleOver);
      _Event["default"].addEvent(this.circleRight.current, 'mouseout', this.handleOut);
      // }

      // if (this.circleLeft && this.circleLeft.current) {
      _Event["default"].addEvent(this.circleLeft.current, 'mouseover', this.handleOver);
      _Event["default"].addEvent(this.circleLeft.current, 'mouseout', this.handleOut);
      // }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.throttleMove);
      _Event["default"].removeEvent(document, 'mouseup', this.handleUp);
      if (this.circleRight && this.circleRight.current) {
        _Event["default"].removeEvent(this.circleRight.current, 'mouseover', this.handleOver);
        _Event["default"].removeEvent(this.circleRight.current, 'mouseout', this.handleOut);
      }
      if (this.circleLeft && this.circleLeft.current) {
        _Event["default"].removeEvent(this.circleLeft.current, 'mouseover', this.handleOver);
        _Event["default"].removeEvent(this.circleLeft.current, 'mouseout', this.handleOut);
      }
    }

    /**
     * 获取当前指针的位置
     */
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        leftPoint = _this$props4.leftPoint,
        showScalePoint = _this$props4.showScalePoint,
        scale = _this$props4.scale,
        width = _this$props4.width,
        showScale = _this$props4.showScale,
        decimalPlaces = _this$props4.decimalPlaces,
        className = _this$props4.className,
        style = _this$props4.style,
        unit = _this$props4.unit,
        disabled = _this$props4.disabled,
        _this$state = this.state,
        left = _this$state.left,
        right = _this$state.right,
        shadow = _this$state.shadow,
        tip = _this$state.tip,
        display = tip || shadow ? '' : 'hide';
      var _this$getScaleValueAn5 = this.getScaleValueAndLabel(scale),
        _this$getScaleValueAn6 = (0, _slicedToArray2["default"])(_this$getScaleValueAn5, 2),
        scaleValue = _this$getScaleValueAn6[0],
        scaleLabel = _this$getScaleValueAn6[1];
      var _this$getPositionFrom2 = this.getPositionFromValue(left, right),
        leftPosition = _this$getPositionFrom2.leftPosition,
        rightPosition = _this$getPositionFrom2.rightPosition;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('slider', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread(_objectSpread({}, style), {}, {
          width: width
        }),
        disabled: disabled
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.sliderBox,
        className: "slider-box ".concat(disabled ? 'disabled' : ''),
        onMouseDown: this.handleClick
      }, showScalePoint ? scaleValue.map(function (item, index) {
        var pointLeft = (item - scaleValue[0]) / (scaleValue[scaleValue.length - 1] - scaleValue[0]) * width,
          min = Math.min(leftPosition, rightPosition),
          max = Math.max(leftPosition, rightPosition);
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "slider-circle fixed-circle ".concat(pointLeft < min || pointLeft > max ? 'disable-circle' : ''),
          style: {
            left: pointLeft
          },
          onMouseDown: _this2.handleDown
        });
      }) : null, leftPoint ? /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.circleLeft,
        className: "slider-circle slider-circle-left ".concat(shadow === 'left' ? 'slider-shadow' : '', " ").concat(disabled ? 'disabled' : ''),
        style: {
          left: leftPosition
        },
        onMouseDown: this.handleDown
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.circleRight,
        className: "slider-circle slider-circle-right ".concat(shadow === 'right' ? 'slider-shadow' : '', " ").concat(disabled ? 'disabled' : ''),
        style: {
          left: rightPosition
        },
        onMouseDown: this.handleDown
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "slider-highlight ".concat(disabled ? 'disabled' : ''),
        style: {
          width: Math.abs(leftPosition - rightPosition),
          left: Math.min(leftPosition, rightPosition)
        }
      }), shadow === 'left' || tip === 'left' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "slider-tip ".concat(display),
        style: {
          left: leftPosition
        }
      }, parseFloat(leftPosition / width * (scaleValue[scaleValue.length - 1] - scaleValue[0]) + scaleValue[0]).toFixed(decimalPlaces)) : /*#__PURE__*/_react["default"].createElement("div", {
        className: "slider-tip ".concat(display),
        style: {
          left: rightPosition
        }
      }, parseFloat(rightPosition / width * (scaleValue[scaleValue.length - 1] - scaleValue[0]) + scaleValue[0]).toFixed(decimalPlaces))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "Slide-scale"
      }, showScale ? /*#__PURE__*/_react["default"].createElement("ul", null, scaleLabel && scaleLabel.map(function (number, index) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: index,
          style: {
            left: (scaleValue[index] - scaleValue[0]) / (scaleValue[scaleValue.length - 1] - scaleValue[0]) * 100 + '%'
          }
        }, number, unit);
      })) : null));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        left: isFinite(props.left) ? _ComponentUtil["default"].getDerivedState(props, state, 'left') : state.left,
        right: isFinite(props.right) ? _ComponentUtil["default"].getDerivedState(props, state, 'right') : state.right
      };
    }
  }]);
  return Slider;
}(_react.Component);
Slider.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * If true,the slider will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the slider will have leftPoint.
   */
  leftPoint: _propTypes["default"].bool,
  /**
   * The width of the slider.
   */
  width: _propTypes["default"].number,
  /**
   * The beginning of a range can select. The range includes the min value.
   */
  minValue: _propTypes["default"].number,
  /**
   * The ending of a range can select. The range includes the max value.
   */
  maxValue: _propTypes["default"].number,
  /**
   * The size displayed on slider.
   */
  scale: _propTypes["default"].array,
  /**
   * If true,the scale will have display.
   */
  showScale: _propTypes["default"].bool,
  /**
   * If true,the scale point will have display.
   */
  showScalePoint: _propTypes["default"].bool,
  /**
   * The granularity the slider can step through values.
   */
  ruler: _propTypes["default"].number,
  /**
   * Decimal digits of tip.
   */
  decimalPlaces: _propTypes["default"].number,
  /**
   * the scale unit.
   */
  unit: _propTypes["default"].string,
  left: _propTypes["default"].number,
  right: _propTypes["default"].number,
  /**
   * Callback function fired when the slider change.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when the slider blur.
   */
  onBlur: _propTypes["default"].func
};
Slider.defaultProps = {
  leftPoint: false,
  showScalePoint: false,
  width: 300,
  scale: [0, 100],
  showScale: false,
  unit: '',
  decimalPlaces: 0
};
var _default = Slider;
exports["default"] = _default;