"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _PositionPop = _interopRequireDefault(require("../_PositionPop"));
var _Toast = _interopRequireDefault(require("../_Toast"));
var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ToasterCalculation = _interopRequireDefault(require("../_vendors/ToasterCalculation"));
var _excluded = ["className", "position", "duration", "autoWidth", "onToastPop"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Toaster = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Toaster, _Component);
  var _super = _createSuper(Toaster);
  function Toaster(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Toaster);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addToast", function (toast) {
      var toasts = _this.state.toasts;
      if (_ToasterCalculation["default"].isPositiveSequence(_this.props.position)) {
        toasts.push(_objectSpread(_objectSpread({}, toast), {}, {
          toastsId: _ToasterCalculation["default"].getToastsKey()
        }));
      } else {
        toasts.unshift(_objectSpread(_objectSpread({}, toast), {}, {
          toastsId: _ToasterCalculation["default"].getToastsKey()
        }));
      }
      _this.setState({
        toasts: toasts,
        visible: true
      }, function () {
        var _this$popInstance, _this$popInstance$res;
        return (_this$popInstance = _this.popInstance) === null || _this$popInstance === void 0 ? void 0 : (_this$popInstance$res = _this$popInstance.resetPosition) === null || _this$popInstance$res === void 0 ? void 0 : _this$popInstance$res.call(_this$popInstance);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeToast", function (toastsId) {
      var toasts = _this.state.toasts;
      if (!toasts || toasts.length < 1) {
        return;
      }
      toasts.splice(toasts.findIndex(function (item) {
        return item.toastsId === toastsId;
      }), 1);
      _this.setState({
        toasts: toasts
      }, function () {
        if (toasts.length < 1) {
          _this.setState({
            visible: false
          }, function () {
            var _this$popInstance2, _this$popInstance2$re;
            return (_this$popInstance2 = _this.popInstance) === null || _this$popInstance2 === void 0 ? void 0 : (_this$popInstance2$re = _this$popInstance2.resetPosition) === null || _this$popInstance2$re === void 0 ? void 0 : _this$popInstance2$re.call(_this$popInstance2);
          });
        }
      });
    });
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.popInstance = null;
    _this.state = {
      visible: false,
      toasts: []
    };
    return _this;
  }
  (0, _createClass2["default"])(Toaster, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$pop;
      this.popInstance = (_this$pop = this.pop) === null || _this$pop === void 0 ? void 0 : _this$pop.current;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this.props.toasts && this.props.toasts.length > 0) {
        var _this$popInstance3, _this$popInstance3$re, _this$props$onToastPo, _this$props;
        (_this$popInstance3 = this.popInstance) === null || _this$popInstance3 === void 0 ? void 0 : (_this$popInstance3$re = _this$popInstance3.resetPosition) === null || _this$popInstance3$re === void 0 ? void 0 : _this$popInstance3$re.call(_this$popInstance3);
        (_this$props$onToastPo = (_this$props = this.props).onToastPop) === null || _this$props$onToastPo === void 0 ? void 0 : _this$props$onToastPo.call(_this$props);
      }
    }

    /**
     * public
     * @param toast
     */
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        position = _this$props2.position,
        duration = _this$props2.duration,
        autoWidth = _this$props2.autoWidth,
        onToastPop = _this$props2.onToastPop,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      var _this$state = this.state,
        toasts = _this$state.toasts,
        visible = _this$state.visible;
      return /*#__PURE__*/_react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('toaster', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "toaster-".concat(position), position), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        visible: visible,
        position: position
      }), (toasts === null || toasts === void 0 ? void 0 : toasts.map(function (options) {
        return /*#__PURE__*/_react["default"].createElement(_Toast["default"], (0, _extends2["default"])({}, options, {
          key: options.toastsId,
          duration: 'duration' in options ? options.duration : duration,
          autoWidth: autoWidth,
          onRequestClose: _this2.removeToast
        }));
      })) || null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (!props.toasts || props.toasts.length < 1) {
        return null;
      }
      var toasts = (0, _cloneDeep["default"])(props.toasts);
      for (var i = 0, len = toasts.length; i < len; i++) {
        if ((0, _typeof2["default"])(toasts[i]) !== 'object') {
          toasts[i] = {
            message: toasts[i]
          };
        }
        toasts[i].toastsId = _ToasterCalculation["default"].getToastsKey();
      }
      if (_ToasterCalculation["default"].isPositiveSequence(props.position)) {
        toasts = [].concat((0, _toConsumableArray2["default"])(state.toasts), (0, _toConsumableArray2["default"])(toasts));
      } else {
        toasts = [].concat((0, _toConsumableArray2["default"])(toasts.reverse()), (0, _toConsumableArray2["default"])(state.toasts));
      }
      return {
        prevProps: props,
        toasts: toasts,
        visible: true
      };
    }
  }]);
  return Toaster;
}(_react.Component);
(0, _defineProperty2["default"])(Toaster, "Type", _MsgType["default"]);
(0, _defineProperty2["default"])(Toaster, "Position", _Position["default"]);
Toaster.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * Children passed into the toaster.
   */
  toasts: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of toast.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the toast.
     */
    style: _propTypes["default"].object,
    /**
     * The type of toast.
     */
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
    /**
     * The message of toast.
     */
    message: _propTypes["default"].string,
    /**
     * The icon class name of toast.
     */
    iconCls: _propTypes["default"].string,
    /**
     * The duration of toast.
     */
    duration: _propTypes["default"].number
  }), _propTypes["default"].string, _propTypes["default"].number])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The duration of toast.
   */
  duration: _propTypes["default"].number,
  autoWidth: _propTypes["default"].bool,
  /**
   * Callback function fired when the toaster pop.
   */
  onToastPop: _propTypes["default"].func
};
Toaster.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].TOP,
  duration: 2500,
  autoWidth: false
};
var _default = Toaster;
exports["default"] = _default;