"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _classnames = _interopRequireDefault(require("classnames"));
var _moment = _interopRequireDefault(require("moment"));
var _DateUtil = _interopRequireDefault(require("../_vendors/DateUtil"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _DateCalculation = _interopRequireDefault(require("../_vendors/DateCalculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DayPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DayPicker, _Component);
  var _super = _createSuper(DayPicker);
  function DayPicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DayPicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousLevel", function () {
      var previousClick = _this.props.previousClick;
      previousClick && previousClick('month');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hoverDateHandle", function (selectDay) {
      var hoverHandle = _this.props.hoverHandle,
        _this$state = _this.state,
        selectYear = _this$state.selectYear,
        selectMonth = _this$state.selectMonth,
        selectedMonth = +selectMonth - 1,
        timer = (0, _moment["default"])([selectYear, selectedMonth, selectDay]).format(_this.props.dateFormat);
      hoverHandle && hoverHandle({
        time: timer,
        year: selectYear,
        month: selectMonth,
        day: selectDay
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (selectDay) {
      var onChange = _this.props.onChange,
        _this$state2 = _this.state,
        selectYear = _this$state2.selectYear,
        selectMonth = _this$state2.selectMonth,
        hour = _this$state2.hour,
        minute = _this$state2.minute,
        second = _this$state2.second,
        selectedMonth = +selectMonth - 1,
        timer = hour && minute && second ? (0, _moment["default"])([selectYear, selectedMonth, selectDay, hour, minute, second]).format(_this.props.dateFormat) : (0, _moment["default"])([selectYear, selectedMonth, selectDay]).format(_this.props.dateFormat);
      _this.setState({
        currentYear: selectYear,
        currentMonth: selectMonth,
        currentDay: selectDay,
        selectDay: selectDay
      }, function () {
        onChange && onChange({
          time: timer,
          year: selectYear,
          month: selectMonth,
          day: selectDay
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var monthAndYearChange = _this.props.monthAndYearChange,
        _this$state3 = _this.state,
        currentYear = _this$state3.currentYear,
        currentMonth = _this$state3.currentMonth,
        currentDay = _this$state3.currentDay,
        selectYear = _this$state3.selectYear,
        selectMonth = _this$state3.selectMonth,
        selectedYear = +selectYear - 1,
        selectedDay = Number(currentYear) === Number(selectedYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;
      _this.setState({
        selectYear: selectedYear,
        selectMonth: selectMonth,
        selectDay: selectedDay,
        dateNumArray: _DateUtil["default"].MonthDays(selectedYear),
        firstDay: _DateCalculation["default"].weekday(selectedYear, selectMonth)
      }, function () {
        monthAndYearChange && monthAndYearChange({
          year: selectedYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousMonth", function () {
      var monthAndYearChange = _this.props.monthAndYearChange,
        _this$state4 = _this.state,
        currentYear = _this$state4.currentYear,
        currentMonth = _this$state4.currentMonth,
        currentDay = _this$state4.currentDay,
        selectYear = _this$state4.selectYear,
        selectMonth = _this$state4.selectMonth,
        dateNumArray = _this$state4.dateNumArray,
        selectedYear = parseInt(selectMonth, 10) === 1 ? +selectYear - 1 : selectYear,
        selectedMonth = parseInt(selectMonth, 10) === 1 ? 12 : +selectMonth - 1,
        selectedDay = Number(currentYear) === Number(selectedYear) && Number(currentMonth) === Number(selectedMonth) ? currentDay : undefined;
      _this.setState({
        selectYear: selectedYear,
        selectMonth: selectedMonth,
        selectDay: selectedDay,
        dateNumArray: parseInt(selectMonth, 10) === 1 ? _DateUtil["default"].MonthDays(selectedYear) : dateNumArray,
        firstDay: _DateCalculation["default"].weekday(selectedYear, selectedMonth)
      }, function () {
        monthAndYearChange && monthAndYearChange({
          year: selectedYear,
          month: selectedMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextMonth", function () {
      var monthAndYearChange = _this.props.monthAndYearChange,
        _this$state5 = _this.state,
        currentYear = _this$state5.currentYear,
        currentMonth = _this$state5.currentMonth,
        currentDay = _this$state5.currentDay,
        selectYear = _this$state5.selectYear,
        selectMonth = _this$state5.selectMonth,
        dateNumArray = _this$state5.dateNumArray,
        selectedYear = parseInt(selectMonth, 10) === 12 ? +selectYear + 1 : selectYear,
        selectedMonth = parseInt(selectMonth, 10) === 12 ? 1 : +selectMonth + 1,
        selectedDay = Number(currentYear) === Number(selectedYear) && Number(currentMonth) === Number(selectedMonth) ? currentDay : undefined;
      _this.setState({
        selectYear: selectedYear,
        selectMonth: selectedMonth,
        selectDay: selectedDay,
        dateNumArray: parseInt(selectMonth, 10) === 12 ? _DateUtil["default"].MonthDays(selectedYear) : dateNumArray,
        firstDay: _DateCalculation["default"].weekday(selectedYear, selectedMonth)
      }, function () {
        monthAndYearChange && monthAndYearChange({
          year: selectedYear,
          month: selectedMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var monthAndYearChange = _this.props.monthAndYearChange,
        _this$state6 = _this.state,
        currentYear = _this$state6.currentYear,
        currentMonth = _this$state6.currentMonth,
        currentDay = _this$state6.currentDay,
        selectYear = _this$state6.selectYear,
        selectMonth = _this$state6.selectMonth,
        selectedYear = +selectYear + 1,
        selectedDay = Number(currentYear) === Number(selectedYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;
      _this.setState({
        selectYear: selectedYear,
        selectMonth: selectMonth,
        selectDay: selectedDay,
        dateNumArray: _DateUtil["default"].MonthDays(selectedYear),
        firstDay: _DateCalculation["default"].weekday(selectedYear, selectMonth)
      }, function () {
        monthAndYearChange && monthAndYearChange({
          year: selectedYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousMonthDaysRender", function () {
      var _this$state7 = _this.state,
        dateNumArray = _this$state7.dateNumArray,
        firstDay = _this$state7.firstDay,
        selectMonth = _this$state7.selectMonth,
        month = +selectMonth - 1,
        previousMonthDays = month === 0 ? 31 : dateNumArray[month - 1];
      var renderArray = [];
      for (var i = 0; i < firstDay; i++) {
        renderArray.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: "item-gray",
          key: 'previous' + i
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, previousMonthDays - (firstDay - i) + 1)));
      }
      return renderArray;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "rangeDateCurrentMonthDaysRender", function () {
      var _DateUtil$getPrevMaxC, _DateUtil$getPrevMaxC2, _DateUtil$getPrevMaxC3, _DateUtil$getPrevMaxC4, _DateUtil$getNextMinC, _DateUtil$getNextMinC2, _DateUtil$getNextMinC3, _DateUtil$getNextMinC4;
      var _this$props = _this.props,
        startTime = _this$props.startTime,
        endTime = _this$props.endTime,
        hoverTime = _this$props.hoverTime,
        maxValue = _this$props.maxValue,
        minValue = _this$props.minValue,
        otherSelectedDate = _this$props.otherSelectedDate,
        _this$state8 = _this.state,
        dateNumArray = _this$state8.dateNumArray,
        selectYear = _this$state8.selectYear,
        selectMonth = _this$state8.selectMonth,
        _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
        selectDate = _assertThisInitialize.selectDate,
        hoverDateHandle = _assertThisInitialize.hoverDateHandle;
      var month = +selectMonth - 1,
        monthDays = dateNumArray[month],
        start = (0, _moment["default"])(endTime).isBefore(startTime) ? endTime : startTime,
        end = (0, _moment["default"])(endTime).isBefore(startTime) ? startTime : endTime,
        hover = (0, _moment["default"])(hoverTime).isBefore(startTime) ? startTime : hoverTime;
      start = (0, _moment["default"])(hoverTime).isBefore(startTime) ? hoverTime : startTime;
      var renderArray = [],
        minDate = !!start && !end ? (_DateUtil$getPrevMaxC = _DateUtil["default"].getPrevMaxCloserDate(startTime, otherSelectedDate)) !== null && _DateUtil$getPrevMaxC !== void 0 && _DateUtil$getPrevMaxC.value[1] && minValue ? _moment["default"].max((0, _moment["default"])(minValue), (0, _moment["default"])((_DateUtil$getPrevMaxC2 = _DateUtil["default"].getPrevMaxCloserDate(startTime, otherSelectedDate)) === null || _DateUtil$getPrevMaxC2 === void 0 ? void 0 : _DateUtil$getPrevMaxC2.value[1])) : (_DateUtil$getPrevMaxC3 = _DateUtil["default"].getPrevMaxCloserDate(startTime, otherSelectedDate)) !== null && _DateUtil$getPrevMaxC3 !== void 0 && _DateUtil$getPrevMaxC3.value[1] && !minValue ? (_DateUtil$getPrevMaxC4 = _DateUtil["default"].getPrevMaxCloserDate(startTime, otherSelectedDate)) === null || _DateUtil$getPrevMaxC4 === void 0 ? void 0 : _DateUtil$getPrevMaxC4.value[1] : minValue : minValue,
        // DateUtil.getPrevMaxCloserDate(startTime, otherSelectedDate)?.value[1] ?
        //     minValue &&
        //     moment(minValue).isBefore(DateUtil.getPrevMaxCloserDate(startTime, otherSelectedDate)?.value[1]) ?
        //         DateUtil.getPrevMaxCloserDate(startTime, otherSelectedDate)?.value[1]
        //         :
        //         minValue
        //     :
        //     minValue
        // :
        // minValue,
        maxDate = !!start && !end ? (_DateUtil$getNextMinC = _DateUtil["default"].getNextMinCloserDate(startTime, otherSelectedDate)) !== null && _DateUtil$getNextMinC !== void 0 && _DateUtil$getNextMinC.value[0] && maxValue ? _moment["default"].min((0, _moment["default"])(maxValue), (0, _moment["default"])((_DateUtil$getNextMinC2 = _DateUtil["default"].getNextMinCloserDate(startTime, otherSelectedDate)) === null || _DateUtil$getNextMinC2 === void 0 ? void 0 : _DateUtil$getNextMinC2.value[0])) : (_DateUtil$getNextMinC3 = _DateUtil["default"].getNextMinCloserDate(startTime, otherSelectedDate)) !== null && _DateUtil$getNextMinC3 !== void 0 && _DateUtil$getNextMinC3.value[0] && !maxValue ? (_DateUtil$getNextMinC4 = _DateUtil["default"].getNextMinCloserDate(startTime, otherSelectedDate)) === null || _DateUtil$getNextMinC4 === void 0 ? void 0 : _DateUtil$getNextMinC4.value[0] : maxValue : maxValue;

      // console.log('maxValue::', maxValue);
      // console.log('minDate::', minDate);
      // console.log('maxDate::', maxDate);
      var _loop = function _loop(i) {
        var _start, _otherSelectedDate$fi;
        var item = (0, _moment["default"])([Number(selectYear), Number(selectMonth) - 1, i + 1]).format('YYYY-MM-DD'),
          liClassName = (0, _classnames["default"])({
            'start': ((_start = start) === null || _start === void 0 ? void 0 : _start.toString()) === (item === null || item === void 0 ? void 0 : item.toString()) || otherSelectedDate.some(function (data) {
              return (0, _moment["default"])(data === null || data === void 0 ? void 0 : data.value[0]).format('YYYY-MM-DD') === (item === null || item === void 0 ? void 0 : item.toString());
            }),
            'end': (item === null || item === void 0 ? void 0 : item.toString()) === (end === null || end === void 0 ? void 0 : end.toString()) || (item === null || item === void 0 ? void 0 : item.toString()) === (hover === null || hover === void 0 ? void 0 : hover.toString()) || otherSelectedDate.some(function (data) {
              return (0, _moment["default"])(data === null || data === void 0 ? void 0 : data.value[1]).format('YYYY-MM-DD') === (item === null || item === void 0 ? void 0 : item.toString());
            }),
            'hover': (0, _moment["default"])(start).isBefore(item) && (0, _moment["default"])(item).isBefore(end) || (0, _moment["default"])(start).isBefore(item) && (0, _moment["default"])(item).isBefore(hover),
            'first-day': i === 0,
            'last-day': i === +monthDays - 1,
            'item-gray': minDate && (0, _moment["default"])(item).isBefore(minDate) || maxDate && (0, _moment["default"])(maxDate).isBefore(item),
            'current-days': !(minDate && (0, _moment["default"])(item).isBefore(minDate)) || maxDate && (0, _moment["default"])(maxDate).isBefore(item),
            'other-selected': otherSelectedDate.length > 0 ? otherSelectedDate.some(function (data) {
              return (0, _moment["default"])(item).isBetween(data === null || data === void 0 ? void 0 : data.value[0], data === null || data === void 0 ? void 0 : data.value[1], null, '[]');
            }) : false
          });
        renderArray.push(liClassName.indexOf('other-selected') > -1 ? /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
          key: 'currentTip' + i,
          tipContent: (_otherSelectedDate$fi = otherSelectedDate.find(function (data) {
            return (0, _moment["default"])(item).isBetween(data === null || data === void 0 ? void 0 : data.value[0], data === null || data === void 0 ? void 0 : data.value[1], null, '[]');
          })) === null || _otherSelectedDate$fi === void 0 ? void 0 : _otherSelectedDate$fi.tip
        }, /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, i + 1))) : /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            return liClassName.indexOf('item-gray') === -1 && selectDate(i + 1);
          },
          onMouseOver: function onMouseOver() {
            return liClassName.indexOf('item-gray') === -1 && hoverDateHandle(i + 1);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, i + 1, liClassName.indexOf('item-gray') === -1 ? /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null) : null)));
      };
      for (var i = 0; i < Number(monthDays); i++) {
        _loop(i);
      }
      return renderArray;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "singleDateCurrentMonthDaysRender", function () {
      var _this$props2 = _this.props,
        maxValue = _this$props2.maxValue,
        minValue = _this$props2.minValue,
        _this$state9 = _this.state,
        dateNumArray = _this$state9.dateNumArray,
        selectYear = _this$state9.selectYear,
        selectMonth = _this$state9.selectMonth,
        selectDay = _this$state9.selectDay,
        currentYear = _this$state9.currentYear,
        currentMonth = _this$state9.currentMonth,
        _assertThisInitialize2 = (0, _assertThisInitialized2["default"])(_this),
        selectDate = _assertThisInitialize2.selectDate;
      var month = +selectMonth - 1,
        monthDays = dateNumArray[month];
      var renderArray = [];
      var _loop2 = function _loop2(i) {
        var item = (0, _moment["default"])([Number(selectYear), Number(selectMonth) - 1, i + 1]).format('YYYY-MM-DD'),
          liClassName = (0, _classnames["default"])({
            'active': +selectYear === +currentYear && +selectMonth === +currentMonth && i + 1 === +selectDay,
            'item-gray': minValue && (0, _moment["default"])(item).isBefore(minValue) || maxValue && (0, _moment["default"])(maxValue).isBefore(item),
            'current-days': !(minValue && (0, _moment["default"])(item).isBefore(minValue)) || maxValue && (0, _moment["default"])(maxValue).isBefore(item)
          });
        renderArray.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            return liClassName.indexOf('item-gray') === -1 && selectDate(i + 1);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, i + 1, liClassName.indexOf('item-gray') === -1 ? /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null) : null)));
      };
      for (var i = 0; i < Number(monthDays); i++) {
        _loop2(i);
      }
      return renderArray;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextMonthDaysRender", function () {
      var _this$state10 = _this.state,
        dateNumArray = _this$state10.dateNumArray,
        selectMonth = _this$state10.selectMonth,
        firstDay = _this$state10.firstDay,
        month = +selectMonth - 1,
        monthDays = dateNumArray[month],
        nextDays = _this.defaultTable.rowNumber * _this.defaultTable.colNumber - firstDay - monthDays;
      var renderArray = [];
      for (var i = 0; i < nextDays; i++) {
        renderArray.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: "item-gray",
          key: 'previous' + i
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, i + 1)));
      }
      return renderArray;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "daysRender", function () {
      var isRange = _this.props.isRange;
      var allDaysRenderArray = [],
        totalDays = [],
        previousDays = _this.previousMonthDaysRender(),
        currentDays = isRange ? _this.rangeDateCurrentMonthDaysRender() : _this.singleDateCurrentMonthDaysRender(),
        nextDays = _this.nextMonthDaysRender();
      totalDays = previousDays.concat(currentDays, nextDays);
      if (totalDays.length > 0) {
        for (var i = 0; i < _this.defaultTable.rowNumber; i++) {
          var weekList = [],
            startIndex = i * _this.defaultTable.colNumber,
            endIndex = (i + 1) * _this.defaultTable.colNumber;
          for (var j = startIndex; j < endIndex; j++) {
            weekList.push(totalDays[j]);
          }
          allDaysRenderArray.push(weekList);
        }
      }
      return allDaysRenderArray;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calendarHeaderLeftRender", function () {
      var _this$props3 = _this.props,
        minValue = _this$props3.minValue,
        previousYearIconCls = _this$props3.previousYearIconCls,
        previousMonthIconCls = _this$props3.previousMonthIconCls,
        _this$state11 = _this.state,
        selectYear = _this$state11.selectYear,
        selectMonth = _this$state11.selectMonth,
        dateNumArray = _this$state11.dateNumArray,
        _assertThisInitialize3 = (0, _assertThisInitialized2["default"])(_this),
        previousMonth = _assertThisInitialize3.previousMonth,
        previousYear = _assertThisInitialize3.previousYear,
        currentMonthMaxDay = dateNumArray[+selectMonth - 1],
        previousYearEl = minValue ? +(0, _moment["default"])(minValue).format('YYYY') < +selectYear - 1 || +(0, _moment["default"])(minValue).format('YYYY') === +selectYear - 1 && +(0, _moment["default"])(minValue).format('MM') <= +selectMonth ? /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('previous-year', (0, _defineProperty2["default"])({}, previousYearIconCls, previousYearIconCls)),
          onClick: previousYear
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)) : null : /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('previous-year', (0, _defineProperty2["default"])({}, previousYearIconCls, previousYearIconCls)),
          onClick: previousYear
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)),
        previousMonthEl = minValue ? +(0, _moment["default"])(minValue).format('YYYY') === +selectYear && ((0, _moment["default"])(minValue).isBefore((0, _moment["default"])([selectYear, +selectMonth - 1, currentMonthMaxDay])) ? +(0, _moment["default"])(minValue).format('MM') <= +selectMonth - 1 : +(0, _moment["default"])(minValue).format('MM') < +selectMonth) || +(0, _moment["default"])(minValue).format('YYYY') < +selectYear ? /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('previous-month', (0, _defineProperty2["default"])({}, previousMonthIconCls, previousMonthIconCls)),
          onClick: previousMonth
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)) : null : /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('previous-month', (0, _defineProperty2["default"])({}, previousMonthIconCls, previousMonthIconCls)),
          onClick: previousMonth
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null));
      return previousYearEl || previousMonthEl ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, previousYearEl, previousMonthEl) : null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calendarHeaderRightRender", function () {
      var _this$props4 = _this.props,
        maxValue = _this$props4.maxValue,
        nextYearIconCls = _this$props4.nextYearIconCls,
        nextMonthIconCls = _this$props4.nextMonthIconCls,
        _this$state12 = _this.state,
        selectYear = _this$state12.selectYear,
        selectMonth = _this$state12.selectMonth,
        _assertThisInitialize4 = (0, _assertThisInitialized2["default"])(_this),
        nextYear = _assertThisInitialize4.nextYear,
        nextMonth = _assertThisInitialize4.nextMonth;
      var nextMonthEl = maxValue ? +(0, _moment["default"])(maxValue).format('YYYY') === +selectYear && ((0, _moment["default"])(maxValue).isAfter((0, _moment["default"])([selectYear, +selectMonth - 1, 1])) ? +(0, _moment["default"])(maxValue).format('MM') > selectMonth : +(0, _moment["default"])(maxValue).format('MM') >= selectMonth) || maxValue && +selectYear < +(0, _moment["default"])(maxValue).format('YYYY') ? /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('next-month', (0, _defineProperty2["default"])({}, nextMonthIconCls, nextMonthIconCls)),
          onClick: nextMonth
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)) : null : /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('next-month', (0, _defineProperty2["default"])({}, nextMonthIconCls, nextMonthIconCls)),
          onClick: nextMonth
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)),
        nextYearEl = maxValue ? +selectYear < +(0, _moment["default"])(maxValue).format('YYYY') - 1 || +selectYear === +(0, _moment["default"])(maxValue).format('YYYY') - 1 && +selectMonth <= +(0, _moment["default"])(maxValue).format('MM') ? /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('next-year', (0, _defineProperty2["default"])({}, nextYearIconCls, nextYearIconCls)),
          onClick: nextYear
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)) : null : /*#__PURE__*/_react["default"].createElement("i", {
          className: (0, _classnames["default"])('next-year', (0, _defineProperty2["default"])({}, nextYearIconCls, nextYearIconCls)),
          onClick: nextYear
        }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null));
      return nextMonthEl || nextYearEl ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, nextMonthEl, nextYearEl) : null;
    });
    _this.defaultTable = {
      rowNumber: 6,
      colNumber: 7
    };
    _this.state = {
      selectYear: props.year,
      selectMonth: props.month,
      selectDay: props.day,
      hour: props.hour,
      minute: props.minute,
      second: props.second,
      currentYear: (0, _moment["default"])(props.value).format('YYYY'),
      currentMonth: (0, _moment["default"])(props.value).format('MM'),
      currentDay: (0, _moment["default"])(props.value).format('DD'),
      dateNumArray: _DateUtil["default"].MonthDays(props.year),
      firstDay: _DateCalculation["default"].weekday(props.year, props.month)
    };
    return _this;
  }
  (0, _createClass2["default"])(DayPicker, [{
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        isFooter = _this$props5.isFooter,
        isRange = _this$props5.isRange,
        _this$state13 = this.state,
        selectYear = _this$state13.selectYear,
        selectMonth = _this$state13.selectMonth,
        previousLevel = this.previousLevel,
        MonthEn = _DateUtil["default"].getMonth(+selectMonth),
        calendarHeaderLeftRender = this.calendarHeaderLeftRender(),
        calendarHeaderRightRender = this.calendarHeaderRightRender(),
        daysRenderArray = this.daysRender();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-header"
      }, calendarHeaderLeftRender ? calendarHeaderLeftRender : null, /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames["default"])('date-text', {
          disabled: !calendarHeaderLeftRender && !calendarHeaderRightRender
        }),
        onClick: function onClick() {
          (calendarHeaderLeftRender || calendarHeaderRightRender) && (previousLevel === null || previousLevel === void 0 ? void 0 : previousLevel());
        }
      }, MonthEn, " ", selectYear), calendarHeaderRightRender ? calendarHeaderRightRender : null), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('calendar-body', 'calendar-day-body', {
          'maxHeight': !isFooter,
          'isRange': isRange
        })
      }, /*#__PURE__*/_react["default"].createElement("ul", {
        className: "c-body-head"
      }, /*#__PURE__*/_react["default"].createElement("li", null, "Sun"), /*#__PURE__*/_react["default"].createElement("li", null, "Mon"), /*#__PURE__*/_react["default"].createElement("li", null, "Tue"), /*#__PURE__*/_react["default"].createElement("li", null, "Wed"), /*#__PURE__*/_react["default"].createElement("li", null, "Thu"), /*#__PURE__*/_react["default"].createElement("li", null, "Fri"), /*#__PURE__*/_react["default"].createElement("li", null, "Sat")), /*#__PURE__*/_react["default"].createElement("div", {
        className: "c-body-content"
      }, daysRenderArray && daysRenderArray.map(function (item, key) {
        return /*#__PURE__*/_react["default"].createElement("ul", {
          className: "content-row margin-5",
          key: 'ul' + key
        }, item);
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        selectYear = _ComponentUtil["default"].getDerivedState(props, state, 'year', 'selectYear'),
        selectMonth = _ComponentUtil["default"].getDerivedState(props, state, 'month', 'selectMonth'),
        selectDay = _ComponentUtil["default"].getDerivedState(props, state, 'day', 'selectDay');
      return {
        prevProps: props,
        value: value,
        selectYear: selectYear,
        selectMonth: selectMonth,
        selectDay: selectDay,
        hour: _ComponentUtil["default"].getDerivedState(props, state, 'hour'),
        minute: _ComponentUtil["default"].getDerivedState(props, state, 'minute'),
        second: _ComponentUtil["default"].getDerivedState(props, state, 'second'),
        currentYear: (0, _moment["default"])(value).format('YYYY'),
        currentMonth: (0, _moment["default"])(value).format('MM'),
        currentDay: (0, _moment["default"])(value).format('DD'),
        dateNumArray: _DateUtil["default"].MonthDays(selectYear),
        firstDay: _DateCalculation["default"].weekday(selectYear, selectMonth)
      };
    }
  }]);
  return DayPicker;
}(_react.Component);
DayPicker.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  value: _propTypes["default"].any,
  startTime: _propTypes["default"].string,
  endTime: _propTypes["default"].any,
  hoverTime: _propTypes["default"].any,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  hour: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  minute: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  second: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  dateFormat: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  isRange: _propTypes["default"].bool,
  otherSelectedDate: _propTypes["default"].array,
  isFooter: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  hoverHandle: _propTypes["default"].func,
  monthAndYearChange: _propTypes["default"].func,
  previousClick: _propTypes["default"].func
};
DayPicker.defaultProps = {
  isFooter: false,
  otherSelectedDate: []
};
var _default = DayPicker;
exports["default"] = _default;