"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Pop = _interopRequireDefault(require("../_Pop"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _PositionPopCalculation = _interopRequireDefault(require("../_vendors/PositionPopCalculation"));
var _excluded = ["children", "container", "className", "theme", "position", "isAnimated", "isEscClose", "isBlurClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var PositionPop = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PositionPop, _Component);
  var _super = _createSuper(PositionPop);
  function PositionPop(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, PositionPop);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      var _this$pop, _this$pop$current, _this$pop$current$get;
      return ((_this$pop = _this.pop) === null || _this$pop === void 0 ? void 0 : (_this$pop$current = _this$pop.current) === null || _this$pop$current === void 0 ? void 0 : (_this$pop$current$get = _this$pop$current.getEl) === null || _this$pop$current$get === void 0 ? void 0 : _this$pop$current$get.call(_this$pop$current)) || null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var transitionEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getEl();
      var _this$props = _this.props,
        parentEl = _this$props.parentEl,
        position = _this$props.position;
      _PositionPopCalculation["default"].setStyle(parentEl, transitionEl, position);
    });
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(PositionPop, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        children = _this$props2.children,
        container = _this$props2.container,
        className = _this$props2.className,
        theme = _this$props2.theme,
        position = _this$props2.position,
        isAnimated = _this$props2.isAnimated,
        isEscClose = _this$props2.isEscClose,
        isBlurClose = _this$props2.isBlurClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_Pop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('position-pop', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "position-pop-".concat(position), position), (0, _defineProperty2["default"])(_classNames, 'position-pop-animated', isAnimated), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        container: container,
        isAnimated: isAnimated,
        position: position,
        resetPosition: this.resetPosition
      }), function (popEl) {
        return typeof children === 'function' ? children(popEl) : children;
      });
    }
  }]);
  return PositionPop;
}(_react.Component);
(0, _defineProperty2["default"])(PositionPop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(PositionPop, "Theme", _Theme["default"]);
PositionPop.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * If true, the trigger pop is visible.
   */
  visible: _propTypes["default"].bool,
  /**
   * The trigger pop theme. Can be primary, highlight, success, warning, error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,
  /**
   * The trigger pop alignment. The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,
  container: _propTypes["default"].node,
  showModal: _propTypes["default"].bool,
  modalClassName: _propTypes["default"].string,
  shouldResetPosition: _propTypes["default"].bool,
  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
PositionPop.defaultProps = {
  parentEl: document.body,
  depth: 2,
  visible: false,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].CENTER,
  isAnimated: true,
  isBlurClose: true,
  isEscClose: true,
  container: /*#__PURE__*/_react["default"].createElement("div", null),
  showModal: false,
  shouldResetPosition: true
};
var _default = PositionPop;
exports["default"] = _default;