"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tf = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tf, _Component);
  var _super = _createSuper(Tf);
  function Tf(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tf);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props = _this.props,
        rowIndex = _this$props.rowIndex,
        colIndex = _this$props.colIndex,
        rowData = _this$props.rowData,
        tableData = _this$props.tableData,
        footData = _this$props.footData,
        scrollEl = _this$props.scrollEl,
        renderer = _this$props.renderer,
        bodyRenderer = _this$props.bodyRenderer;
      if (typeof renderer === 'function') {
        return renderer(rowData, rowIndex, colIndex, tableData, footData, bodyRenderer, scrollEl);
      }
      return renderer;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTitle", function () {
      var _this$props2 = _this.props,
        colIndex = _this$props2.colIndex,
        tableData = _this$props2.tableData,
        scrollEl = _this$props2.scrollEl,
        title = _this$props2.title;
      if (typeof title === 'function') {
        return title(tableData, colIndex, scrollEl);
      }
      return title;
    });
    return _this;
  }

  /**
   * Handle th content render
   * @returns {*}
   */
  (0, _createClass2["default"])(Tf, [{
    key: "render",
    value: function render() {
      var _classNames, _this$handleTitle;
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        align = _this$props3.align,
        noWrap = _this$props3.noWrap,
        span = _this$props3.span,
        onCellClick = _this$props3.onCellClick;
      return /*#__PURE__*/_react["default"].createElement("td", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, 'no-wrap', noWrap), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        colSpan: span || null,
        title: ((_this$handleTitle = this.handleTitle()) === null || _this$handleTitle === void 0 ? void 0 : _this$handleTitle.toString()) || null,
        onClick: onCellClick
      }, this.handleRender());
    }
  }]);
  return Tf;
}(_react.Component);
(0, _defineProperty2["default"])(Tf, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tf, "SortingType", _SortingType["default"]);
Tf.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  rowIndex: _propTypes["default"].number,
  colIndex: _propTypes["default"].number,
  rowData: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  title: _propTypes["default"].any,
  renderer: _propTypes["default"].any,
  bodyRenderer: _propTypes["default"].any,
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  span: _propTypes["default"].number,
  noWrap: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  onCellClick: _propTypes["default"].func
};
Tf.defaultProps = {
  colIndex: 0,
  align: _HorizontalAlign["default"].LEFT,
  noWrap: false
};
var _default = Tf;
exports["default"] = _default;