"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TimeItems = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TimeItems, _Component);
  var _super = _createSuper(TimeItems);
  function TimeItems(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TimeItems);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (value) {
      if (!value) {
        return;
      }
      _this.scrollTo(_this.wrapperEl, +value * 30, 200);
      var onChange = _this.props.onChange;
      onChange && onChange(value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function () {
      _this.wrapperEl && (_this.wrapperEl.style.overflowY = 'auto');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollTo", function (element, to, duration) {
      if (!element) {
        return;
      }

      // jump to target if duration zero
      if (duration <= 0) {
        element.scrollTop = to;
        return;
      }
      var difference = to - element.scrollTop,
        perTick = difference / duration * 10;
      setTimeout(function () {
        element.scrollTop = element.scrollTop + perTick;
        if (element.scrollTop === to) return;
        _this.scrollTo(element, to, duration - 10);
      }, 10);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function () {
      _this.wrapperEl && (_this.wrapperEl.style.overflowY = 'hidden');
    });
    _this.wrapperEl = null;
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }
  (0, _createClass2["default"])(TimeItems, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var value = this.props.value;
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.scrollTo(this.wrapperEl, +value * 30, 0);
      _Event["default"].addEvent(this.wrapperEl, 'mouseover', this.handleMouseMove);
      _Event["default"].addEvent(this.wrapperEl, 'mouseout', this.handleMouseOut);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (prevProps.value !== this.props.value) {
        this.scrollTo(this.wrapperEl, +this.props.value * 30, 200);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(this.wrapperEl, 'mouseover', this.handleMouseMove);
      _Event["default"].removeEvent(this.wrapperEl, 'mouseout', this.handleMouseOut);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        data = _this$props.data,
        value = _this$props.value,
        width = style.width,
        liStyle = {};
      if (width == '100%') {
        liStyle.paddingLeft = '140px';
      } else if (width == '50%') {
        liStyle.paddingLeft = '60px';
      } else {
        liStyle.paddingLeft = '36px';
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('time-items', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("ul", {
        className: "time-list"
      }, data && data.length ? data.map(function (item, key) {
        return /*#__PURE__*/_react["default"].createElement("li", {
          className: (0, _classnames["default"])('time-item', {
            disabled: !item.value,
            active: item.text == value
          }),
          key: key,
          style: liStyle,
          onClick: function onClick() {
            return _this2.handleClick(item.text);
          }
        }, item.text);
      }) : null));
    }
  }]);
  return TimeItems;
}(_react.Component);
TimeItems.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  data: _propTypes["default"].array,
  value: _propTypes["default"].any,
  onChange: _propTypes["default"].func
};
var _default = TimeItems;
exports["default"] = _default;