"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TimeLineItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TimeLineItem, _Component);
  var _super = _createSuper(TimeLineItem);
  function TimeLineItem(props) {
    (0, _classCallCheck2["default"])(this, TimeLineItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(TimeLineItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        date = _this$props.date,
        theme = _this$props.theme,
        type = _this$props.type,
        headerText = _this$props.headerText,
        contentText = _this$props.contentText,
        hasBorder = _this$props.hasBorder,
        style = _this$props.style;
      return /*#__PURE__*/_react["default"].createElement("li", {
        className: (0, _classnames["default"])('time-line-item', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, type && type == 'header' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "time-line-item-header"
      }, headerText) : type && type == 'title' ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "time-line-item-title time-line-item-title-".concat(theme)
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "tl-date"
      }, date), hasBorder ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "tl-content panel panel-".concat(theme)
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "triangle triangle-".concat(theme)
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "tag tag-".concat(theme)
      }), /*#__PURE__*/_react["default"].createElement("div", null, contentText)) : /*#__PURE__*/_react["default"].createElement("div", {
        className: "tl-content"
      }, contentText)) : null);
    }
  }]);
  return TimeLineItem;
}(_react.Component);
(0, _defineProperty2["default"])(TimeLineItem, "Type", {
  HEADER: 'header',
  TITLE: 'title'
});
TimeLineItem.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object
};
var _default = TimeLineItem;
exports["default"] = _default;