"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
/**
 * @file RateCalculation vendor
 */

function createItems(value, allowHalf, count) {
  var items = [];
  if (allowHalf) {
    for (var i = 0; i < count; i++) {
      if (i <= value - 1) {
        items.push('full');
      } else if (i < value && i > value - 1) {
        items.push('full-zero');
      } else if (i > value) {
        items.push('zero');
      } else {
        items.push('zero');
      }
    }
  } else {
    for (var _i = 0; _i < count; _i++) {
      if (_i < value) {
        items.push('full');
      } else if (_i > value) {
        items.push('zero');
      } else {
        items.push('zero');
      }
    }
  }
  return items;
}
var _default = {
  createItems: createItems
};
exports["default"] = _default;