"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _Position = _interopRequireDefault(require("../_statics/Position"));
/**
 * @file ToasterCalculation vendor
 */

var toastsKey = 0;
function getToastsKey() {
  return toastsKey++;
}
function isPositiveSequence(position) {
  return position !== _Position["default"].BOTTOM_LEFT && position !== _Position["default"].BOTTOM && position !== _Position["default"].BOTTOM_RIGHT;
}
var _default = {
  getToastsKey: getToastsKey,
  isPositiveSequence: isPositiveSequence
};
exports["default"] = _default;