"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _CursorPop = _interopRequireDefault(require("../_CursorPop"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["className", "contentClassName", "onRequestClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CursorPopover = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CursorPopover, _Component);
  var _super = _createSuper(CursorPopover);
  function CursorPopover(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CursorPopover);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var _this$popInstance, _this$popInstance$res;
      (_this$popInstance = _this.popInstance) === null || _this$popInstance === void 0 ? void 0 : (_this$popInstance$res = _this$popInstance.resetPosition) === null || _this$popInstance$res === void 0 ? void 0 : _this$popInstance$res.call(_this$popInstance);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearCloseTimeout", function () {
      if (_this.closeTimeout) {
        clearTimeout(_this.closeTimeout);
        _this.closeTimeout = null;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function () {
      _this.clearCloseTimeout();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      _this.clearCloseTimeout();
      var enterable = _this.props.enterable;
      if (enterable) {
        _this.closeTimeout = setTimeout(function () {
          var _this$props$onRequest, _this$props;
          return (_this$props$onRequest = (_this$props = _this.props).onRequestClose) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call(_this$props, e);
        }, 1000 / 6);
      } else {
        var _this$props$onRequest2, _this$props2;
        (_this$props$onRequest2 = (_this$props2 = _this.props).onRequestClose) === null || _this$props$onRequest2 === void 0 ? void 0 : _this$props$onRequest2.call(_this$props2, e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function (el, triggerEl) {
      var _this$props$onRender, _this$props3;
      var enterable = _this.props.enterable;
      (_this$props$onRender = (_this$props3 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call(_this$props3, el, triggerEl);
      _Event["default"].addEvent(triggerEl, 'mouseover', _this.handleMouseOver);
      _Event["default"].addEvent(triggerEl, 'mouseout', _this.handleMouseOut);
      if (enterable) {
        _Event["default"].addEvent(el, 'mouseover', _this.handleMouseOver);
        _Event["default"].addEvent(el, 'mouseout', _this.handleMouseOut);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function (el, triggerEl) {
      var _this$props$onDestroy, _this$props4;
      var enterable = _this.props.enterable;
      (_this$props$onDestroy = (_this$props4 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call(_this$props4, el, triggerEl);
      _Event["default"].removeEvent(triggerEl, 'mouseover', _this.handleMouseOver);
      _Event["default"].removeEvent(triggerEl, 'mouseout', _this.handleMouseOut);
      if (enterable) {
        _Event["default"].removeEvent(el, 'mouseover', _this.handleMouseOver);
        _Event["default"].removeEvent(el, 'mouseout', _this.handleMouseOut);
      }
    });
    _this.closeTimeout = null;
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.popInstance = null;
    return _this;
  }
  (0, _createClass2["default"])(CursorPopover, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$pop;
      this.popInstance = (_this$pop = this.pop) === null || _this$pop === void 0 ? void 0 : _this$pop.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearCloseTimeout();
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        className = _this$props5.className,
        contentClassName = _this$props5.contentClassName,
        onRequestClose = _this$props5.onRequestClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props5, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_CursorPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('cursor-popover', (0, _defineProperty2["default"])({}, className, className)),
        contentClassName: (0, _classnames["default"])('cursor-popover-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName)),
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }));
    }
  }]);
  return CursorPopover;
}(_react.Component);
(0, _defineProperty2["default"])(CursorPopover, "Position", _Position["default"]);
(0, _defineProperty2["default"])(CursorPopover, "Theme", _Theme["default"]);
CursorPopover.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the CursorPopover.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the CursorPopover is visible.
   */
  visible: _propTypes["default"].bool,
  container: _propTypes["default"].element,
  /**
   * The CursorPopover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The CursorPopover alignment.The value can be CursorPopover.Position.LEFT or CursorPopover.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, CursorPopover will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  enterable: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  /**
   * The function of CursorPopover render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of CursorPopover rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of CursorPopover destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of CursorPopover destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when the CursorPopover is requested to be closed.
   */
  onRequestClose: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  onCursorMove: _propTypes["default"].func,
  onTargetChange: _propTypes["default"].func
};
CursorPopover.defaultProps = {
  parentEl: document.body,
  visible: false,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].BOTTOM_LEFT,
  isAnimated: true,
  enterable: false,
  shouldFollowScroll: false,
  resetPositionWait: 250
};
var _default = CursorPopover;
exports["default"] = _default;