"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Dropdown = _interopRequireDefault(require("../Dropdown"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _GroupList = _interopRequireDefault(require("../GroupList"));
var _List = _interopRequireDefault(require("../List"));
var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "triggerClassName", "popupClassName", "style", "name", "popupTheme", "data", "triggerRenderer", "useDynamicRenderList", "itemHeight", "scrollBuffer", "renderer", "listItemRenderer", "selectMode", "itemDisabled", "useFilter", "filterIconCls", "useSelectAll", "selectAllText", "valueField", "displayField", "descriptionField", "popupChildren", "isHiddenInputFilter", "noMatchedMsg", "isGrouped", "filterPlaceholder", "radioUncheckedIconCls", "radioCheckedIconCls", "checkboxUncheckedIconCls", "checkboxCheckedIconCls", "checkboxIndeterminateIconCls", "onListDataChange", "value", "clearHiddenInputFilterInterval", "listHeight", "onOpenPopup", "onClosePopup", "onItemClick", "onBeforeChange", "onChange", "onFilterChange"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DropdownSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DropdownSelect, _Component);
  var _super = _createSuper(DropdownSelect);
  function DropdownSelect(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DropdownSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      var _this$dropdownInstanc, _this$dropdownInstanc2;
      (_this$dropdownInstanc = _this.dropdownInstance) === null || _this$dropdownInstanc === void 0 ? void 0 : (_this$dropdownInstanc2 = _this$dropdownInstanc.startRipple) === null || _this$dropdownInstanc2 === void 0 ? void 0 : _this$dropdownInstanc2.call(_this$dropdownInstanc, e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      var _this$dropdownInstanc3, _this$dropdownInstanc4;
      (_this$dropdownInstanc3 = _this.dropdownInstance) === null || _this$dropdownInstanc3 === void 0 ? void 0 : (_this$dropdownInstanc4 = _this$dropdownInstanc3.endRipple) === null || _this$dropdownInstanc4 === void 0 ? void 0 : _this$dropdownInstanc4.call(_this$dropdownInstanc3);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      var _this$dropdownInstanc5, _this$dropdownInstanc6;
      (_this$dropdownInstanc5 = _this.dropdownInstance) === null || _this$dropdownInstanc5 === void 0 ? void 0 : (_this$dropdownInstanc6 = _this$dropdownInstanc5.triggerRipple) === null || _this$dropdownInstanc6 === void 0 ? void 0 : _this$dropdownInstanc6.call(_this$dropdownInstanc5, e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      var _this$dropdownInstanc7, _this$dropdownInstanc8;
      (_this$dropdownInstanc7 = _this.dropdownInstance) === null || _this$dropdownInstanc7 === void 0 ? void 0 : (_this$dropdownInstanc8 = _this$dropdownInstanc7.resetPosition) === null || _this$dropdownInstanc8 === void 0 ? void 0 : _this$dropdownInstanc8.call(_this$dropdownInstanc7);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      var _this$dropdownInstanc9, _this$dropdownInstanc10;
      (_this$dropdownInstanc9 = _this.dropdownInstance) === null || _this$dropdownInstanc9 === void 0 ? void 0 : (_this$dropdownInstanc10 = _this$dropdownInstanc9.openPopup) === null || _this$dropdownInstanc10 === void 0 ? void 0 : _this$dropdownInstanc10.call(_this$dropdownInstanc9);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      var _this$dropdownInstanc11, _this$dropdownInstanc12;
      (_this$dropdownInstanc11 = _this.dropdownInstance) === null || _this$dropdownInstanc11 === void 0 ? void 0 : (_this$dropdownInstanc12 = _this$dropdownInstanc11.closePopup) === null || _this$dropdownInstanc12 === void 0 ? void 0 : _this$dropdownInstanc12.call(_this$dropdownInstanc11);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getListHeight", function () {
      var _this$actions, _this$actions$current, _this$popupChildren, _this$popupChildren$c;
      var result = _this.props.listHeight;
      if (!result) {
        return result;
      }
      if ((_this$actions = _this.actions) !== null && _this$actions !== void 0 && (_this$actions$current = _this$actions.current) !== null && _this$actions$current !== void 0 && _this$actions$current.offsetHeight) {
        result -= _this.actions.current.offsetHeight;
      }
      if ((_this$popupChildren = _this.popupChildren) !== null && _this$popupChildren !== void 0 && (_this$popupChildren$c = _this$popupChildren.current) !== null && _this$popupChildren$c !== void 0 && _this$popupChildren$c.offsetHeight) {
        result -= _this.popupChildren.current.offsetHeight;
      }
      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateScrollHeight", function () {
      var _this$actions2, _this$actions2$curren, _this$popupChildren2, _this$popupChildren2$;
      if (!_this.scroller || !_this.scroller.current) {
        return;
      }
      var scrollerEl = _this.scroller.current,
        popEl = _Dom["default"].findParentByClassName(scrollerEl, 'popup-content');
      if (!popEl) {
        return;
      }
      var scrollTop = scrollerEl.scrollTop;
      scrollerEl.style.height = 'auto';
      var scrollerHeight = popEl.offsetHeight;
      if ((_this$actions2 = _this.actions) !== null && _this$actions2 !== void 0 && (_this$actions2$curren = _this$actions2.current) !== null && _this$actions2$curren !== void 0 && _this$actions2$curren.offsetHeight) {
        scrollerHeight -= _this.actions.current.offsetHeight;
      }
      if ((_this$popupChildren2 = _this.popupChildren) !== null && _this$popupChildren2 !== void 0 && (_this$popupChildren2$ = _this$popupChildren2.current) !== null && _this$popupChildren2$ !== void 0 && _this$popupChildren2$.offsetHeight) {
        scrollerHeight -= _this.popupChildren.current.offsetHeight;
      }
      scrollerEl.style.height = "".concat(scrollerHeight, "px");
      scrollerEl.scrollTop = scrollTop;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        var _this$props$onFilterC, _this$props, _this$dropdown, _this$dropdown$curren, _this$dropdown$curren2;
        (_this$props$onFilterC = (_this$props = _this.props).onFilterChange) === null || _this$props$onFilterC === void 0 ? void 0 : _this$props$onFilterC.call(_this$props, filter);
        (_this$dropdown = _this.dropdown) === null || _this$dropdown === void 0 ? void 0 : (_this$dropdown$curren = _this$dropdown.current) === null || _this$dropdown$curren === void 0 ? void 0 : (_this$dropdown$curren2 = _this$dropdown$curren.resetPopupPosition) === null || _this$dropdown$curren2 === void 0 ? void 0 : _this$dropdown$curren2.call(_this$dropdown$curren);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;
      if (!filter) {
        return data;
      }
      var _this$props2 = _this.props,
        displayField = _this$props2.displayField,
        isGrouped = _this$props2.isGrouped,
        filterCallback = _this$props2.filterCallback,
        filterFunc = function filterFunc(originData) {
          return originData.filter(function (item) {
            return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
          });
        };
      if (filterCallback) {
        return filterCallback(filter, data);
      }
      if (isGrouped) {
        return data && data.map(function (group) {
          var children = filterFunc(group.children);
          if (children.length < 1) {
            return null;
          } else {
            return _objectSpread(_objectSpread({}, group), {}, {
              children: children
            });
          }
        }).filter(function (item) {
          return !!item;
        });
      }
      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAllClick", function () {
      var data = _this.props.data,
        value = _this.state.value;
      if (!data) {
        return;
      }
      var isSelectAll = !value || value && value.length < data.length,
        newValue = isSelectAll ? data : [];
      _this.setState({
        value: newValue
      }, function () {
        return _this.handleChange(newValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemClick", function () {
      var _this$props$onItemCli, _this$props3;
      if (_this.props.autoClose) {
        _this.closePopup();
      }
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      (_this$props$onItemCli = (_this$props3 = _this.props).onItemClick) === null || _this$props$onItemCli === void 0 ? void 0 : _this$props$onItemCli.call.apply(_this$props$onItemCli, [_this$props3].concat(args));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var _this$props$onBeforeC, _this$props4;
      if (_this.props.autoClose) {
        _this.closePopup();
      }
      if (((_this$props$onBeforeC = (_this$props4 = _this.props).onBeforeChange) === null || _this$props$onBeforeC === void 0 ? void 0 : _this$props$onBeforeC.call(_this$props4, value, _this.state.value)) === false) {
        return;
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props$onChange, _this$props5;
        return (_this$props$onChange = (_this$props5 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props5, value);
      });
      setTimeout(function () {
        var _this$hiddenFilter, _this$hiddenFilter$cu, _this$hiddenFilter$cu2;
        return (_this$hiddenFilter = _this.hiddenFilter) === null || _this$hiddenFilter === void 0 ? void 0 : (_this$hiddenFilter$cu = _this$hiddenFilter.current) === null || _this$hiddenFilter$cu === void 0 ? void 0 : (_this$hiddenFilter$cu2 = _this$hiddenFilter$cu.focus) === null || _this$hiddenFilter$cu2 === void 0 ? void 0 : _this$hiddenFilter$cu2.call(_this$hiddenFilter$cu);
      }, 1000);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupOpen", function (e) {
      var _this$props6 = _this.props,
        isHiddenInputFilter = _this$props6.isHiddenInputFilter,
        useFilter = _this$props6.useFilter;
      if (isHiddenInputFilter) {
        var _this$hiddenFilter2, _this$hiddenFilter2$c, _this$hiddenFilter2$c2;
        (_this$hiddenFilter2 = _this.hiddenFilter) === null || _this$hiddenFilter2 === void 0 ? void 0 : (_this$hiddenFilter2$c = _this$hiddenFilter2.current) === null || _this$hiddenFilter2$c === void 0 ? void 0 : (_this$hiddenFilter2$c2 = _this$hiddenFilter2$c.focus) === null || _this$hiddenFilter2$c2 === void 0 ? void 0 : _this$hiddenFilter2$c2.call(_this$hiddenFilter2$c);
      } else if (useFilter) {
        var _this$filter, _this$filter$current, _this$filter$current$;
        (_this$filter = _this.filter) === null || _this$filter === void 0 ? void 0 : (_this$filter$current = _this$filter.current) === null || _this$filter$current === void 0 ? void 0 : (_this$filter$current$ = _this$filter$current.focus) === null || _this$filter$current$ === void 0 ? void 0 : _this$filter$current$.call(_this$filter$current);
      }
      _this.setState({
        popupVisible: true
      }, function () {
        var _this$props$onOpenPop, _this$props7;
        return (_this$props$onOpenPop = (_this$props7 = _this.props).onOpenPopup) === null || _this$props$onOpenPop === void 0 ? void 0 : _this$props$onOpenPop.call(_this$props7, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupClose", function (e) {
      var _this$hiddenFilter3, _this$hiddenFilter3$c, _this$hiddenFilter3$c2;
      (_this$hiddenFilter3 = _this.hiddenFilter) === null || _this$hiddenFilter3 === void 0 ? void 0 : (_this$hiddenFilter3$c = _this$hiddenFilter3.current) === null || _this$hiddenFilter3$c === void 0 ? void 0 : (_this$hiddenFilter3$c2 = _this$hiddenFilter3$c.blur) === null || _this$hiddenFilter3$c2 === void 0 ? void 0 : _this$hiddenFilter3$c2.call(_this$hiddenFilter3$c);
      _this.setState({
        popupVisible: false
      }, function () {
        var _this$props$onClosePo, _this$props8;
        return (_this$props$onClosePo = (_this$props8 = _this.props).onClosePopup) === null || _this$props$onClosePo === void 0 ? void 0 : _this$props$onClosePo.call(_this$props8, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHiddenFilterChange", function (e) {
      var _this$scroller;
      var _this$props9 = _this.props,
        data = _this$props9.data,
        displayField = _this$props9.displayField,
        clearHiddenInputFilterInterval = _this$props9.clearHiddenInputFilterInterval;
      if (!data) {
        return;
      }
      var target = e.target,
        timer = setTimeout(function () {
          clearTimeout(timer);
          target.value = '';
        }, clearHiddenInputFilterInterval);
      var index = data.findIndex(function (item) {
        return (0, _typeof2["default"])(item) === 'object' ? item[displayField].toUpperCase().startsWith(target.value.toUpperCase()) : item.toUpperCase().startsWith(target.value.toUpperCase());
      });
      ((_this$scroller = _this.scroller) === null || _this$scroller === void 0 ? void 0 : _this$scroller.current) && _this.scrollTo(_this.scroller.current, index * 40, 200);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollTo", function (element, to, duration) {
      if (!element) {
        return;
      }

      // jump to target if duration zero
      if (duration <= 0) {
        element.scrollTop = to;
        return;
      }
      var difference = to - element.scrollTop,
        perTick = difference / duration * 10;
      setTimeout(function () {
        element.scrollTop = element.scrollTop + perTick;
        if (element.scrollTop === to) {
          return;
        }
        _this.scrollTo(element, to, duration - 10);
      }, 10);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTriggerValue", function () {
      var _this$props10 = _this.props,
        placeholder = _this$props10.placeholder,
        triggerRenderer = _this$props10.triggerRenderer,
        renderer = _this$props10.renderer,
        valueField = _this$props10.valueField,
        displayField = _this$props10.displayField,
        selectMode = _this$props10.selectMode,
        value = _this.state.value,
        isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT;
      if (triggerRenderer) {
        return typeof triggerRenderer === 'function' ? triggerRenderer(value) : triggerRenderer;
      }
      if (!value) {
        return placeholder;
      }
      return isMultiSelect ? value.length > 0 ? value.length + ' selected' : placeholder : renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField);
    });
    _this.hiddenFilter = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdown = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownInstance = null;
    _this.actions = /*#__PURE__*/(0, _react.createRef)();
    _this.filter = /*#__PURE__*/(0, _react.createRef)();
    _this.scroller = /*#__PURE__*/(0, _react.createRef)();
    _this.popupChildren = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      value: _props.value,
      filter: '',
      popupVisible: false
    };
    return _this;
  }
  (0, _createClass2["default"])(DropdownSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$dropdown2;
      this.dropdownInstance = (_this$dropdown2 = this.dropdown) === null || _this$dropdown2 === void 0 ? void 0 : _this$dropdown2.current;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.updateScrollHeight();
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this$props11 = this.props,
        className = _this$props11.className,
        triggerClassName = _this$props11.triggerClassName,
        popupClassName = _this$props11.popupClassName,
        style = _this$props11.style,
        name = _this$props11.name,
        popupTheme = _this$props11.popupTheme,
        data = _this$props11.data,
        triggerRenderer = _this$props11.triggerRenderer,
        useDynamicRenderList = _this$props11.useDynamicRenderList,
        itemHeight = _this$props11.itemHeight,
        scrollBuffer = _this$props11.scrollBuffer,
        renderer = _this$props11.renderer,
        listItemRenderer = _this$props11.listItemRenderer,
        selectMode = _this$props11.selectMode,
        itemDisabled = _this$props11.itemDisabled,
        useFilter = _this$props11.useFilter,
        filterIconCls = _this$props11.filterIconCls,
        useSelectAll = _this$props11.useSelectAll,
        selectAllText = _this$props11.selectAllText,
        valueField = _this$props11.valueField,
        displayField = _this$props11.displayField,
        descriptionField = _this$props11.descriptionField,
        popupChildren = _this$props11.popupChildren,
        isHiddenInputFilter = _this$props11.isHiddenInputFilter,
        noMatchedMsg = _this$props11.noMatchedMsg,
        isGrouped = _this$props11.isGrouped,
        filterPlaceholder = _this$props11.filterPlaceholder,
        radioUncheckedIconCls = _this$props11.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props11.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props11.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props11.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props11.checkboxIndeterminateIconCls,
        onListDataChange = _this$props11.onListDataChange,
        v = _this$props11.value,
        clearHiddenInputFilterInterval = _this$props11.clearHiddenInputFilterInterval,
        listHeight = _this$props11.listHeight,
        onOpenPopup = _this$props11.onOpenPopup,
        onClosePopup = _this$props11.onClosePopup,
        onItemClick = _this$props11.onItemClick,
        onBeforeChange = _this$props11.onBeforeChange,
        onChange = _this$props11.onChange,
        onFilterChange = _this$props11.onFilterChange,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props11, _excluded),
        _this$state = this.state,
        value = _this$state.value,
        filter = _this$state.filter,
        popupVisible = _this$state.popupVisible,
        isMultiSelect = selectMode === _SelectMode["default"].MULTI_SELECT,
        listData = this.filterData();
      onListDataChange === null || onListDataChange === void 0 ? void 0 : onListDataChange(listData);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('dropdown-select', (0, _defineProperty2["default"])({
          activated: popupVisible
        }, className, className)),
        style: style
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, isHiddenInputFilter ? /*#__PURE__*/_react["default"].createElement("input", {
        ref: this.hiddenFilter,
        className: "hiddenFilter",
        type: "text",
        onChange: this.handleHiddenFilterChange
      }) : null, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        triggerClassName: (0, _classnames["default"])((0, _defineProperty2["default"])({
          empty: !triggerRenderer && !value
        }, triggerClassName, triggerClassName)),
        popupClassName: 'dropdown-select-popup' + (popupClassName ? ' ' + popupClassName : ''),
        popupTheme: popupTheme,
        triggerValue: this.getTriggerValue(),
        onOpenPopup: this.handlePopupOpen,
        onClosePopup: this.handlePopupClose
      }), useFilter || isMultiSelect && useSelectAll ? /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.actions,
        className: "dropdown-select-popup-actions"
      }, useFilter ? /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.filter,
        className: "dropdown-select-filter",
        value: filter,
        placeholder: filterPlaceholder,
        rightIconCls: filterIconCls,
        onChange: this.handleFilterChange
      }) : null, isMultiSelect && useSelectAll ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "list-item dropdown-select-all-wrapper",
        onClick: this.handleSelectAllClick
      }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        className: "list-item-select",
        checked: data && value && value.length === data.length,
        indeterminate: data && value && value.length > 0 && value.length < data.length,
        uncheckedIconCls: checkboxUncheckedIconCls,
        checkedIconCls: checkboxCheckedIconCls,
        indeterminateIconCls: checkboxIndeterminateIconCls
      }), selectAllText) : null) : null, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.scroller,
        className: "dropdown-select-list-scroller"
      }, !listData || listData.length < 1 ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "no-matched"
      }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-exclamation-triangle no-matched-icon"
      }), "No matched value.")) : isGrouped ? /*#__PURE__*/_react["default"].createElement(_GroupList["default"], {
        className: "group-select-list",
        value: value,
        selectMode: selectMode,
        data: listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        itemHeight: itemHeight,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      }) : useDynamicRenderList ? /*#__PURE__*/_react["default"].createElement(_DynamicRenderList["default"], {
        className: "dropdown-select-list",
        theme: popupTheme,
        selectMode: selectMode,
        data: listData,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        listHeight: this.getListHeight(),
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      }) : /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "dropdown-select-list",
        theme: popupTheme,
        selectMode: selectMode,
        data: listData,
        value: value,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        itemDisabled: itemDisabled,
        renderer: listItemRenderer || renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: this.handleItemClick,
        onChange: this.handleChange
      })), /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.popupChildren,
        className: "dropdown-select-popup-children"
      }, popupChildren)));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return DropdownSelect;
}(_react.Component);
(0, _defineProperty2["default"])(DropdownSelect, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "Position", _Position["default"]);
(0, _defineProperty2["default"])(DropdownSelect, "TipPosition", _Position["default"]);
DropdownSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the dropDownSelect.
   */
  name: _propTypes["default"].string,
  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,
  /**
   * The placeholder of the dropDownSelect.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  triggerRenderer: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
  rightIconCls: _propTypes["default"].string,
  /**
   * The options' data.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    title: _propTypes["default"].string,
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true, the button will have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]),
  /**
   * The invalid message of dropDownSelect.
   */
  invalidMsg: _propTypes["default"].string,
  /**
   * If true,the dropDownSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the dropDownSelect will be loading.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  /**
   * The select mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * The message of the dropDownSelect.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * Use this function to format the options' text.
   */
  textFormat: _propTypes["default"].func,
  /**
   * If true, the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * If true, the drop-down box automatically closed when it blur.
   */
  isBlurClose: _propTypes["default"].bool,
  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,
  /**
   * If true,the dropDownSelect will be grouped.
   */
  isGrouped: _propTypes["default"].bool,
  filterIconCls: _propTypes["default"].string,
  filterPlaceholder: _propTypes["default"].string,
  useSelectAll: _propTypes["default"].bool,
  selectAllText: _propTypes["default"].string,
  isHiddenInputFilter: _propTypes["default"].bool,
  clearHiddenInputFilterInterval: _propTypes["default"].number,
  /**
   * The message of no matching option.
   */
  noMatchedMsg: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  useDynamicRenderList: _propTypes["default"].bool,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  resetPopPositionWait: _propTypes["default"].number,
  autoPopupWidth: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  renderer: _propTypes["default"].func,
  listItemRenderer: _propTypes["default"].func,
  filterCallback: _propTypes["default"].func,
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is open.
   */
  onOpenPopup: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is close.
   */
  onClosePopup: _propTypes["default"].func,
  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onBeforeChange: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onFilterChange: _propTypes["default"].func,
  onListDataChange: _propTypes["default"].func
};
DropdownSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  data: [],
  disabled: false,
  isLoading: false,
  itemDisabled: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  tipPosition: _Position["default"].BOTTOM,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true,
  isBlurClose: true,
  useFilter: false,
  filterIconCls: 'fas fa-search',
  filterPlaceholder: 'Search ...',
  useSelectAll: false,
  selectAllText: 'Select All',
  useDynamicRenderList: false,
  isHiddenInputFilter: false,
  clearHiddenInputFilterInterval: 1000,
  isGrouped: false,
  resetPopPositionWait: 250,
  autoPopupWidth: true,
  listHeight: 200,
  itemHeight: 40,
  scrollBuffer: 8
};
var _default = DropdownSelect;
exports["default"] = _default;