"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ListStepItem = _interopRequireDefault(require("../_ListStepItem"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ListStep = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ListStep, _Component);
  var _super = _createSuper(ListStep);
  function ListStep(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ListStep);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (activatedStep) {
      var onChange = _this.props.onChange;
      _this.setState({
        activatedStep: activatedStep
      }, function () {
        onChange && onChange({
          activatedStep: activatedStep,
          finishedStep: _this.state.finishedStep
        });
      });
    });
    _this.state = {
      activatedStep: props.activatedStep,
      finishedStep: props.finishedStep
    };
    return _this;
  }
  (0, _createClass2["default"])(ListStep, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        steps = _this$props.steps,
        _this$state = this.state,
        activatedStep = _this$state.activatedStep,
        finishedStep = _this$state.finishedStep;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('list-step', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, steps && steps.map(function (item, index) {
        return /*#__PURE__*/_react["default"].createElement(_ListStepItem["default"], {
          key: index,
          index: index,
          className: item.className,
          style: _objectSpread(_objectSpread({}, item.style), {}, {
            zIndex: steps.length - index
          }),
          activatedStep: activatedStep,
          finishedStep: finishedStep,
          data: item,
          onClick: _this2.handleClick
        });
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        activatedStep: _ComponentUtil["default"].getDerivedState(props, state, 'activatedStep'),
        finishedStep: _ComponentUtil["default"].getDerivedState(props, state, 'finishedStep')
      };
    }
  }]);
  return ListStep;
}(_react.Component);
ListStep.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The render content of step.
   */
  steps: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of step element.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the step element.
     */
    style: _propTypes["default"].object,
    /**
     * The text value of step.
     */
    title: _propTypes["default"].string
  })).isRequired,
  /**
   * Sets the step as active.
   */
  activatedStep: _propTypes["default"].number,
  /**
   * The final step.
   */
  finishedStep: _propTypes["default"].number,
  /**
   * Callback function fired when step change.
   */
  onChange: _propTypes["default"].func
};
ListStep.defaultProps = {
  steps: [],
  activatedStep: 0,
  finishedStep: 0
};
var _default = ListStep;
exports["default"] = _default;