"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _List = _interopRequireDefault(require("../List"));
var _GroupList = _interopRequireDefault(require("../GroupList"));
var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MultipleSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MultipleSelect, _Component);
  var _super = _createSuper(MultipleSelect);
  function MultipleSelect(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MultipleSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;
      if (!filter) {
        return data;
      }
      var _this$props = _this.props,
        displayField = _this$props.displayField,
        filterCallback = _this$props.filterCallback,
        isGrouped = _this$props.isGrouped;
      if (filterCallback) {
        return filterCallback(filter, data);
      }
      var filterFunc = function filterFunc(originData) {
        return originData.filter(function (item) {
          return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
        });
      };
      if (isGrouped) {
        return data && data.map(function (group) {
          var children = filterFunc(group.children);
          if (children.length < 1) {
            return;
          } else {
            return _objectSpread(_objectSpread({}, group), {}, {
              children: children
            });
          }
        }).filter(function (item) {
          return !!item;
        });
      }
      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeSelected", function (index, e) {
      e.preventDefault();
      setTimeout(function () {
        var value = _this.state.value;
        if (!value || value.length < 1) {
          return;
        }
        value.splice(index, 1);
        _this.setState({
          value: value
        }, function () {
          var onChange = _this.props.onChange;
          onChange && onChange(value);
        });
      }, 0);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleSelectedCollapse", function () {
      _this.setState({
        selectedCollapsed: !_this.state.selectedCollapsed,
        popupVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focusHandler", function () {
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        onFocus = _this$props2.onFocus;
      !disabled && _this.setState({
        popupVisible: true
      }, function () {
        onFocus && onFocus();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blurHandler", function () {
      var _this$props3 = _this.props,
        disabled = _this$props3.disabled,
        onBlur = _this$props3.onBlur;
      !disabled && onBlur && onBlur();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterChangeHandler", function (filter) {
      _this.setState({
        filter: filter
      }, function () {
        _this.popInstance && _this.popInstance.resetPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "popupRenderHandler", function (popupEl) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.wrapperEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "changeHandler", function (value) {
      var autoClose = _this.props.autoClose,
        state = {
          value: value
        };
      if (autoClose) {
        state.popupVisible = false;
      }
      _this.setState(state, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
        setTimeout(function () {
          _this.popInstance && _this.popInstance.resetPosition();
        }, 0);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerHandler", function (el, triggerEl, popupEl, currentVisible) {
      if (!triggerEl) {
        return true;
      }
      while (el) {
        if (el == _this.refs.multipleSelect || el == popupEl || el == triggerEl) {
          return currentVisible;
        }
        el = el.parentNode;
      }
      return false;
    });
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.popInstance = null;
    _this.state = {
      selectedCollapsed: true,
      value: props.value,
      filter: '',
      popupVisible: false,
      isAbove: false
    };
    return _this;
  }
  (0, _createClass2["default"])(MultipleSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
      this.popInstance = this.pop && this.pop.current;
    }
  }, {
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _classNames,
        _this2 = this;
      var _this$props4 = this.props,
        className = _this$props4.className,
        popupClassName = _this$props4.popupClassName,
        style = _this$props4.style,
        popupStyle = _this$props4.popupStyle,
        theme = _this$props4.theme,
        name = _this$props4.name,
        placeholder = _this$props4.placeholder,
        isGrouped = _this$props4.isGrouped,
        useDynamicRenderList = _this$props4.useDynamicRenderList,
        listHeight = _this$props4.listHeight,
        itemHeight = _this$props4.itemHeight,
        scrollBuffer = _this$props4.scrollBuffer,
        position = _this$props4.position,
        resetPopPositionWait = _this$props4.resetPopPositionWait,
        disabled = _this$props4.disabled,
        iconCls = _this$props4.iconCls,
        rightIconCls = _this$props4.rightIconCls,
        valueField = _this$props4.valueField,
        displayField = _this$props4.displayField,
        descriptionField = _this$props4.descriptionField,
        noMatchedMsg = _this$props4.noMatchedMsg,
        parentEl = _this$props4.parentEl,
        _this$state = this.state,
        selectedCollapsed = _this$state.selectedCollapsed,
        isAbove = _this$state.isAbove,
        value = _this$state.value,
        filter = _this$state.filter,
        popupVisible = _this$state.popupVisible,
        emptyEl = [{
          itemRenderer: function itemRenderer() {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: "no-matched-list-item"
            }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
              className: "fas fa-exclamation-triangle no-matched-list-item-icon"
            }), "No matched value."));
          }
        }],
        isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove,
        valueLen = value ? value.length : 0,
        listData = this.filterData(),
        isEmpty = listData.length < 1;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('multiple-select', isAboveFinally ? 'above' : 'blow', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, 'not-empty', valueLen > 0), (0, _defineProperty2["default"])(_classNames, "activated", popupVisible), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, value && valueLen > 0 ? /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('multiple-select-selected-wrapper', isAboveFinally ? 'above' : 'blow', {
          collapsed: selectedCollapsed
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "multiple-select-selected-count"
      }, "".concat(valueLen, " selected")), value && value.map(function (item, index) {
        var text = _Util["default"].getTextByDisplayField(item, displayField, valueField);
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "multiple-select-selected",
          title: text
        }, text, /*#__PURE__*/_react["default"].createElement("div", {
          className: "multiple-select-selected-remove-button",
          onClick: function onClick(e) {
            e.preventDefault();
            _this2.removeSelected(index, e);
          }
        }, "\xD7"));
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "multiple-select-selected-collapse-button",
        iconCls: "fas fa-angle-double-up",
        onClick: this.toggleSelectedCollapse
      })) : null, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: "multiple-select-trigger",
        theme: theme,
        value: filter,
        placeholder: placeholder,
        disabled: disabled,
        iconCls: iconCls,
        rightIconCls: rightIconCls || 'fas fa-search',
        onFocus: this.focusHandler,
        onBlur: this.blurHandler,
        onChange: this.filterChangeHandler
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        ref: this.pop,
        className: (0, _classnames["default"])('multiple-select-popup', isAboveFinally ? 'above' : 'blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        theme: theme,
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        onRender: this.popupRenderHandler,
        onRequestClose: this.closePopup
      }, !isEmpty && isGrouped ? /*#__PURE__*/_react["default"].createElement(_GroupList["default"], {
        className: "multiple-select-list",
        theme: theme,
        value: value,
        selectMode: isEmpty ? _SelectMode["default"].DEFAULT : _SelectMode["default"].MULTI_SELECT,
        data: isEmpty ? emptyEl : listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        onChange: this.changeHandler
      }) : useDynamicRenderList ? /*#__PURE__*/_react["default"].createElement(_DynamicRenderList["default"], {
        className: "multiple-select-list",
        theme: theme,
        value: value,
        selectMode: isEmpty ? _SelectMode["default"].DEFAULT : _SelectMode["default"].MULTI_SELECT,
        data: isEmpty ? emptyEl : listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        listHeight: listHeight,
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        onChange: this.changeHandler
      }) : /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "multiple-select-list",
        theme: theme,
        value: value,
        selectMode: isEmpty ? _SelectMode["default"].DEFAULT : _SelectMode["default"].MULTI_SELECT,
        data: isEmpty ? emptyEl : listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        onChange: this.changeHandler
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return MultipleSelect;
}(_react.Component);
(0, _defineProperty2["default"])(MultipleSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MultipleSelect, "Position", _Position["default"]);
MultipleSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the auto complete.
   */
  name: _propTypes["default"].string,
  /**
   * The placeholder of the field.
   */
  placeholder: _propTypes["default"].string,
  /**
   * Children passed into the List.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  value: _propTypes["default"].any,
  /**
   * If true, the auto complete will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the popup list automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * Callback function fired when value changed.
   */
  filterCallback: _propTypes["default"].func,
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * The message of no value matched.
   */
  noMatchedMsg: _propTypes["default"].string,
  /**
   * If true,the multipleSelect will be grouped.
   */
  isGrouped: _propTypes["default"].bool,
  useDynamicRenderList: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  /**
   * Callback function fired when MultipleSelect changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when the text field focused.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when the text field Defocused.
   */
  onBlur: _propTypes["default"].func
};
MultipleSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  name: '',
  placeholder: '',
  data: [],
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: false,
  iconCls: '',
  rightIconCls: '',
  noMatchedMsg: '',
  isGrouped: false,
  useDynamicRenderList: false,
  resetPopPositionWait: 250
};
var _default = MultipleSelect;
exports["default"] = _default;