"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var SpanLoading = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(SpanLoading, _Component);
  var _super = _createSuper(SpanLoading);
  function SpanLoading(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, SpanLoading);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    _this.state = {
      spanning: props.spanning
    };
    return _this;
  }
  (0, _createClass2["default"])(SpanLoading, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        description = _this$props.description,
        size = _this$props.size,
        children = _this$props.children,
        spanning = this.state.spanning;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('span-loading', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "span-loading-".concat(size), size), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }, spanning ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "span-loading-dot ".concat(size ? size : '')
      }, /*#__PURE__*/_react["default"].createElement("i", null), /*#__PURE__*/_react["default"].createElement("i", null), /*#__PURE__*/_react["default"].createElement("i", null), /*#__PURE__*/_react["default"].createElement("i", null)) : null, children, description ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "span-loading-text"
      }, description) : null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        spanning: _ComponentUtil["default"].getDerivedState(props, state, 'spanning')
      };
    }
  }]);
  return SpanLoading;
}(_react.Component);
SpanLoading.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * If true,will show a span loading animation.
   */
  spanning: _propTypes["default"].bool,
  /**
   * Set the tip text,there will be a description under the loading.
   */
  tip: _propTypes["default"].string,
  /**
   * Set the size of loading,can use small or large.
   */
  size: _propTypes["default"].string,
  description: _propTypes["default"].any
};
SpanLoading.defaultProps = {
  spanning: true,
  tip: '',
  type: ''
};
var _default = SpanLoading;
exports["default"] = _default;