"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _List = _interopRequireDefault(require("../List"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _HorizontalDirection = _interopRequireDefault(require("../_statics/HorizontalDirection"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _CascaderCalculation = _interopRequireDefault(require("../_vendors/CascaderCalculation"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CascaderListItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CascaderListItem, _Component);
  var _super = _createSuper(CascaderListItem);
  function CascaderListItem(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CascaderListItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "findDataIndex", function () {
      var _this$props = _this.props,
        activatedPath = _this$props.activatedPath,
        data = _this$props.data,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField;
      var _iterator = _createForOfIteratorHelper(data),
        _step;
      try {
        var _loop = function _loop() {
          var dataItem = _step.value;
          var index = activatedPath.findIndex(function (item) {
            return item && _Util["default"].getValueByValueField(item.node, valueField, displayField) === _Util["default"].getValueByValueField(dataItem, valueField, displayField);
          });
          if (index > -1) {
            return {
              v: index
            };
          }
        };
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _ret = _loop();
          if ((0, _typeof2["default"])(_ret) === "object") return _ret.v;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return -1;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getActivatedIndex", function () {
      var _this$props2 = _this.props,
        activatedPath = _this$props2.activatedPath,
        data = _this$props2.data;
      if (!activatedPath || activatedPath.length < 1 || !data) {
        return -1;
      }
      var index = _this.findDataIndex();
      return index < 0 ? -1 : activatedPath[index].index;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isExpanded", function (node, index) {
      return index === _this.getActivatedIndex() && node.children && node.children.length > 0;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getCurrentPathNode", function () {
      var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getActivatedIndex();
      var data = _this.props.data;
      return index > -1 ? {
        index: index,
        node: data[index]
      } : null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPath", function () {
      var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getActivatedIndex();
      var path = _this.props.path,
        currentPathNode = _this.getCurrentPathNode(index);
      return path.length > 0 ? [].concat((0, _toConsumableArray2["default"])(path), [currentPathNode]) : [currentPathNode];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getValue", function () {
      var _this$props3 = _this.props,
        selectMode = _this$props3.selectMode,
        value = _this$props3.value,
        activatedPath = _this$props3.activatedPath,
        depth = _this$props3.depth;
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        return value || [];
      }
      return activatedPath && activatedPath[depth] && activatedPath[depth].node || null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isListItemIndeterminate", function (node) {
      if (!_this.props.isSelectRecursive || _this.props.selectMode === _SelectMode["default"].SINGLE_SELECT) {
        return false;
      }
      return _Calculation["default"].isItemIndeterminate(node, _this.props.value, _this.props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemClick", function (node, index, e) {
      var _this$props4 = _this.props,
        data = _this$props4.data,
        disabled = _this$props4.disabled,
        isLoading = _this$props4.isLoading,
        readOnly = _this$props4.readOnly;
      if (disabled || isLoading || readOnly || data.disabled || data.isLoading || data.readOnly) {
        return;
      }
      var onNodeClick = _this.props.onNodeClick;
      onNodeClick && onNodeClick(node, index, _this.getPath(index), e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemSelect", function (node, index) {
      var onNodeSelect = _this.props.onNodeSelect;
      onNodeSelect && onNodeSelect(node, _this.getPath(index));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemDeselect", function (node, index) {
      var onNodeDeselect = _this.props.onNodeDeselect;
      onNodeDeselect && onNodeDeselect(node, _this.getPath(index));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "listItemRenderer", function (node, index) {
      if (!node) {
        return null;
      }
      var _this$props5 = _this.props,
        depth = _this$props5.depth,
        activatedPath = _this$props5.activatedPath,
        parentPath = _this$props5.path,
        expandDirection = _this$props5.expandDirection,
        valueField = _this$props5.valueField,
        displayField = _this$props5.displayField,
        descriptionField = _this$props5.descriptionField,
        expandedIconCls = _this$props5.expandedIconCls,
        renderer = _this$props5.renderer,
        expandIconVisible = _this$props5.expandIconVisible,
        path = [].concat((0, _toConsumableArray2["default"])(parentPath), [{
          index: index,
          node: node
        }]),
        hasChildren = _CascaderCalculation["default"].hasChildren(node),
        hasExpandIcon = expandIconVisible && typeof expandIconVisible === 'function' ? expandIconVisible(node, index, depth, path, activatedPath) : expandDirection === _HorizontalDirection["default"].RIGHT && hasChildren;
      var text, desc;
      if (!renderer) {
        text = _Util["default"].getTextByDisplayField(node, displayField, valueField);
        desc = node[descriptionField] || null;
      }
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, expandDirection === _HorizontalDirection["default"].LEFT && hasChildren ? /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('cascader-list-item-expand-icon', expandedIconCls || 'fas fa-chevron-left'),
        "aria-hidden": "true"
      }) : null, renderer ? renderer(node, index, depth, path, activatedPath) : desc ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "list-item-content"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "list-item-content-value"
      }, text), /*#__PURE__*/_react["default"].createElement("div", {
        className: "list-item-content-desc"
      }, desc)) : text, hasExpandIcon ? /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('cascader-list-item-expand-icon', expandedIconCls || 'fas fa-chevron-right'),
        "aria-hidden": "true"
      }) : null);
    });
    return _this;
  }
  (0, _createClass2["default"])(CascaderListItem, [{
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
        depth = _this$props6.depth,
        theme = _this$props6.theme,
        listWidth = _this$props6.listWidth,
        selectTheme = _this$props6.selectTheme,
        selectMode = _this$props6.selectMode,
        expandDirection = _this$props6.expandDirection,
        data = _this$props6.data,
        disabled = _this$props6.disabled,
        isLoading = _this$props6.isLoading,
        readOnly = _this$props6.readOnly,
        idField = _this$props6.idField,
        valueField = _this$props6.valueField,
        displayField = _this$props6.displayField,
        descriptionField = _this$props6.descriptionField,
        itemDisabled = _this$props6.itemDisabled,
        radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props6.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
        activatedIndex = this.getActivatedIndex(),
        hasChild = activatedIndex > -1 && data[activatedIndex] && data[activatedIndex].children && data[activatedIndex].children.length > 0;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('cascader-list-item', {
          expanded: hasChild
        })
      }, /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: (0, _classnames["default"])('cascader-popup-list', {
          first: depth === 0,
          'expand-left': expandDirection === _HorizontalDirection["default"].LEFT
        }),
        style: {
          width: listWidth
        },
        theme: theme,
        selectTheme: selectTheme,
        selectMode: selectMode,
        data: data,
        value: this.getValue(),
        disabled: disabled,
        isLoading: isLoading,
        readOnly: readOnly,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        autoSelect: selectMode !== _SelectMode["default"].MULTI_SELECT,
        itemDisabled: itemDisabled,
        indeterminateCallback: this.isListItemIndeterminate,
        renderer: this.listItemRenderer,
        onItemClick: this.handleListItemClick,
        onItemSelect: this.handleListItemSelect,
        onItemDeselect: this.handleListItemDeselect
      }), activatedIndex > -1 && data[activatedIndex] && data[activatedIndex].children && data[activatedIndex].children.length > 0 ? /*#__PURE__*/_react["default"].createElement(CascaderListItem, (0, _extends2["default"])({}, this.props, {
        data: data[activatedIndex].children,
        depth: depth + 1,
        path: this.getPath(activatedIndex)
      })) : null);
    }
  }]);
  return CascaderListItem;
}(_react.Component);
(0, _defineProperty2["default"])(CascaderListItem, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(CascaderListItem, "ExpandDirection", _HorizontalDirection["default"]);
(0, _defineProperty2["default"])(CascaderListItem, "Theme", _Theme["default"]);
CascaderListItem.propTypes = {
  index: _propTypes["default"].number,
  depth: _propTypes["default"].number,
  activatedPath: _propTypes["default"].array,
  path: _propTypes["default"].array,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  listWidth: _propTypes["default"].number,
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  expandDirection: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalDirection["default"])),
  data: _propTypes["default"].array,
  value: _propTypes["default"].any,
  idField: _propTypes["default"].string,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  descriptionField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isNodeToggling: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  renderer: _propTypes["default"].func,
  expandIconVisible: _propTypes["default"].func,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  onNodeClick: _propTypes["default"].func,
  onNodeSelect: _propTypes["default"].func,
  onNodeDeselect: _propTypes["default"].func
};
CascaderListItem.defaultProps = {
  index: 0,
  depth: 0,
  activatedPath: [],
  path: [],
  theme: _Theme["default"].DEFAULT,
  listWidth: 200,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  expandDirection: _HorizontalDirection["default"].LEFT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isNodeToggling: false,
  isSelectRecursive: true,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = CascaderListItem;
exports["default"] = _default;