"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Percent = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Percent, _Component);
  var _super = _createSuper(Percent);
  function Percent(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Percent);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "numberChange", function () {
      if (_this.state.percent < 100) {
        if (_this.state.percent < _this.props.endNum) {
          _this.setState({
            percent: _this.state.percent + 1
          });
          var time = 300 / (_this.props.endNum - _this.state.percent);
          _this.timer = setTimeout(function () {
            return _this.numberChange();
          }, time);
          return;
        }
        _this.timer = setTimeout(function () {
          return _this.numberChange();
        }, 30);
      }
    });
    _this.state = {
      percent: 0
    };
    return _this;
  }
  (0, _createClass2["default"])(Percent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.timer = setTimeout(function () {
        return _this2.numberChange();
      }, 30);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        move = _this$props.move,
        endNum = _this$props.endNum,
        status = _this$props.status,
        showIcon = _this$props.showIcon,
        successIcon = _this$props.successIcon,
        failureIcon = _this$props.failureIcon,
        percent = this.state.percent;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-progress-percent', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, className, className), (0, _defineProperty2["default"])(_classNames, status, status), _classNames)),
        style: move === true ? _objectSpread({
          width: endNum + '%',
          textAlign: 'right'
        }, style) : style
      }, _react["default"].Children.map(this.props.children, function (child) {
        return /*#__PURE__*/_react["default"].createElement("span", null, child);
      }), status === 'loading' ? /*#__PURE__*/_react["default"].createElement("span", null, percent, "%") : null, showIcon && status === 'success' ? /*#__PURE__*/_react["default"].createElement("i", {
        className: successIcon || 'fa fa-check-circle'
      }) : null, showIcon && status === 'failure' ? /*#__PURE__*/_react["default"].createElement("i", {
        className: failureIcon || 'fa fa-times-circle'
      }) : null);
    }
  }]);
  return Percent;
}(_react.Component);
(0, _defineProperty2["default"])(Percent, "Status", {
  LOADING: 'loading',
  SUCCESS: 'success',
  FAILURE: 'failure'
});
Percent.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  /**
   * The status of loading.
   */
  status: _propTypes["default"].oneOf(Object.keys(Percent.Status).map(function (key) {
    return Percent.Status[key];
  })),
  endNum: _propTypes["default"].number,
  move: _propTypes["default"].bool,
  showIcon: _propTypes["default"].string,
  successIcon: _propTypes["default"].string,
  failureIcon: _propTypes["default"].string
};
Percent.defaultProps = {
  endNum: 100,
  move: false
};
var _default = Percent;
exports["default"] = _default;