"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var RoundStepItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RoundStepItem, _Component);
  var _super = _createSuper(RoundStepItem);
  function RoundStepItem(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, RoundStepItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getRightBarClassName", function () {
      var _this$props = _this.props,
        activatedStep = _this$props.activatedStep,
        finishedStep = _this$props.finishedStep,
        index = _this$props.index;
      if (finishedStep > index || activatedStep > index) {
        return ' full';
      }
      if (activatedStep === index || finishedStep === index) {
        return '';
      }
      return ' hidden';
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props$onItemCli, _this$props3, _this$props$onClick, _this$props4;
      var _this$props2 = _this.props,
        value = _this$props2.value,
        activatedStep = _this$props2.activatedStep,
        finishedStep = _this$props2.finishedStep,
        index = _this$props2.index,
        disabled = _this$props2.disabled;
      if (disabled) {
        return;
      }
      (_this$props$onItemCli = (_this$props3 = _this.props).onItemClick) === null || _this$props$onItemCli === void 0 ? void 0 : _this$props$onItemCli.call(_this$props3, value, index);
      activatedStep !== index && finishedStep >= index && ((_this$props$onClick = (_this$props4 = _this.props).onClick) === null || _this$props$onClick === void 0 ? void 0 : _this$props$onClick.call(_this$props4, index, e));
    });
    return _this;
  }
  (0, _createClass2["default"])(RoundStepItem, [{
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        className = _this$props5.className,
        style = _this$props5.style,
        activatedStep = _this$props5.activatedStep,
        finishedStep = _this$props5.finishedStep,
        index = _this$props5.index,
        value = _this$props5.value,
        isFirst = _this$props5.isFirst,
        isLast = _this$props5.isLast,
        showFinishedStepIcon = _this$props5.showFinishedStepIcon,
        finishedStepIconCls = _this$props5.finishedStepIconCls,
        disabled = _this$props5.disabled,
        titlePosition = _this$props5.titlePosition;
      var titleEl = /*#__PURE__*/_react["default"].createElement("div", {
        className: "title",
        onClick: this.handleClick
      }, (value === null || value === void 0 ? void 0 : value.title) || '');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('round-step-item', activatedStep === index ? 'activated' : finishedStep >= index ? ' finished' : '', (0, _defineProperty2["default"])({
          first: isFirst,
          last: isLast,
          disabled: disabled
        }, className, className)),
        style: style
      }, titlePosition === _Position["default"].TOP ? titleEl : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "round-step-item-content"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "bg-bar"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "bg-round"
      }), !isFirst && (finishedStep >= index || activatedStep >= index) ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "left-bar"
      }) : null, !isLast ? /*#__PURE__*/_react["default"].createElement("div", {
        className: 'right-bar' + this.getRightBarClassName()
      }) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "round",
        onClick: this.handleClick
      }, showFinishedStepIcon && finishedStep > index ? /*#__PURE__*/_react["default"].createElement("i", {
        className: finishedStepIconCls,
        "aria-hidden": "true"
      }) : value !== null && value !== void 0 && value.iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
        className: value === null || value === void 0 ? void 0 : value.iconCls,
        "aria-hidden": "true"
      }) : index + 1)), titlePosition !== _Position["default"].TOP ? titleEl : null);
    }
  }]);
  return RoundStepItem;
}(_react.Component);
(0, _defineProperty2["default"])(RoundStepItem, "TitlePosition", _Position["default"]);
RoundStepItem.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  activatedStep: _propTypes["default"].number,
  finishedStep: _propTypes["default"].number,
  index: _propTypes["default"].number,
  value: _propTypes["default"].object,
  isFirst: _propTypes["default"].bool,
  isLast: _propTypes["default"].bool,
  showFinishedStepIcon: _propTypes["default"].bool,
  finishedStepIconCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  titlePosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  onItemClick: _propTypes["default"].func,
  onClick: _propTypes["default"].func
};
RoundStepItem.defaultProps = {
  activatedStep: 0,
  finishedStep: 0,
  index: 0,
  value: {},
  isFirst: true,
  isLast: false,
  showFinishedStepIcon: true,
  finishedStepIconCls: 'fas fa-check',
  disabled: false,
  titlePosition: _Position["default"].BOTTOM
};
var _default = RoundStepItem;
exports["default"] = _default;