"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Td = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Td, _Component);
  var _super = _createSuper(Td);
  function Td(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Td);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRenderer", function () {
      var _this$props = _this.props,
        collapsed = _this$props.collapsed,
        renderer = _this$props.renderer,
        rowIndex = _this$props.rowIndex,
        colIndex = _this$props.colIndex,
        data = _this$props.data,
        parentData = _this$props.parentData,
        tableData = _this$props.tableData,
        depth = _this$props.depth,
        path = _this$props.path,
        scrollEl = _this$props.scrollEl;
      switch ((0, _typeof2["default"])(renderer)) {
        case 'function':
          return renderer(data, rowIndex, colIndex, parentData, tableData, collapsed, depth, path, scrollEl);
        default:
          return renderer;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTitle", function () {
      var _this$props2 = _this.props,
        collapsed = _this$props2.collapsed,
        title = _this$props2.title,
        rowIndex = _this$props2.rowIndex,
        colIndex = _this$props2.colIndex,
        data = _this$props2.data,
        parentData = _this$props2.parentData,
        tableData = _this$props2.tableData,
        depth = _this$props2.depth,
        path = _this$props2.path,
        scrollEl = _this$props2.scrollEl;
      switch ((0, _typeof2["default"])(title)) {
        case 'function':
          return title(data, rowIndex, colIndex, parentData, tableData, collapsed, depth, path, scrollEl);
        default:
          return title;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props3 = _this.props,
        data = _this$props3.data,
        rowIndex = _this$props3.rowIndex,
        colIndex = _this$props3.colIndex,
        disabled = _this$props3.disabled,
        onCellClick = _this$props3.onCellClick;
      !disabled && onCellClick && onCellClick(data, rowIndex, colIndex, e);
    });
    return _this;
  }
  (0, _createClass2["default"])(Td, [{
    key: "render",
    value: function render() {
      var _classNames, _this$handleTitle;
      var _this$props4 = this.props,
        className = _this$props4.className,
        style = _this$props4.style,
        align = _this$props4.align,
        span = _this$props4.span,
        noWrap = _this$props4.noWrap,
        sortable = _this$props4.sortable,
        sortingProp = _this$props4.sortingProp,
        sorting = _this$props4.sorting;
      return /*#__PURE__*/_react["default"].createElement("td", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, 'no-wrap', noWrap), (0, _defineProperty2["default"])(_classNames, "sorting", sortable && sortingProp && sorting && sorting.prop && sorting.prop === sortingProp), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        colSpan: span || null,
        title: ((_this$handleTitle = this.handleTitle()) === null || _this$handleTitle === void 0 ? void 0 : _this$handleTitle.toString()) || null,
        onClick: this.handleClick
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "td-column"
      }, this.handleRenderer()));
    }
  }]);
  return Td;
}(_react.Component);
(0, _defineProperty2["default"])(Td, "Align", _HorizontalAlign["default"]);
Td.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  rowIndex: _propTypes["default"].number,
  colIndex: _propTypes["default"].number,
  data: _propTypes["default"].object,
  title: _propTypes["default"].any,
  parentData: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  renderer: _propTypes["default"].any,
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  span: _propTypes["default"].number,
  disabled: _propTypes["default"].bool,
  noWrap: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  depth: _propTypes["default"].number,
  path: _propTypes["default"].array,
  scrollEl: _propTypes["default"].object,
  /**
   * sorting
   */
  sortable: _propTypes["default"].bool,
  sortingProp: _propTypes["default"].string,
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func
};
Td.defaultProps = {
  rowIndex: 0,
  colIndex: 0,
  disabled: false,
  noWrap: false,
  collapsed: true,
  depth: 0
};
var _default = Td;
exports["default"] = _default;