"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
/**
 * @file PureRender vendor
 */

function shouldComponentUpdate(nextProps, nextState) {
  return !(0, _isEqual["default"])(this.props, nextProps) || !(0, _isEqual["default"])(this.state, nextState);
}
function PureRender(component) {
  if (component.prototype.shouldComponentUpdate === undefined) {
    component.prototype.shouldComponentUpdate = shouldComponentUpdate;
  }
  return component;
}
var _default = PureRender;
exports["default"] = _default;